'------------------------------------------------------------------------------
' <auto-generated>
'     This code was generated by Measurement Studio.
'     Runtime Version:2.0.50727.832
'
'     Changes to this file may cause incorrect behavior and will be lost if
'     the code is regenerated.
' </auto-generated>
'------------------------------------------------------------------------------

Option Strict Off
Option Explicit On

Imports System
Imports System.Runtime.InteropServices

Namespace NationalInstruments.ModularInstruments.Interop

    Public Class niHSDIO
        Inherits Object
        Implements System.IDisposable

        Private _handle As System.IntPtr

        Private _disposed As Boolean = True

	Public Structure nihsdio_wfminfo
	public absoluteTimestamp as  System.Int64
	public relativeTimestamp as  System.Int64
	public dt as System.Int64
	public actualSamplesRead as Int32
	public reserved1 as System.Int64
        public reserved2 as System.Int64
        End Structure
        
        Private Sub New(ByVal handle As System.IntPtr)
            MyBase.New()
            Me._handle = handle
            Me._disposed = False
        End Sub

        '''''<summary>
        '''''Creates a new acquisition session.  You can perform static and dynamic acquisition operations with this session.
        '''''
        '''''Creating a new session does not automatically tristate your front panel terminals or channels that might be driving voltages from previous sessions (refer to the niHSDIO_close function for more information on lines left driving after closing a session).
        '''''
        '''''Pass VI_TRUE to the Reset_Instrument parameter to place your device in a known start-up when creating a new session. This action is equivalent to calling niHSDIO_reset, and it tristates the front panel terminals and channels.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Resource_Name">
        '''''Specifies the device name, for example, "Dev1" where "Dev1" is a device name assigned by Measurement & Automation Explorer.
        '''''
        '''''</param>
        '''''<param name="ID_Query">
        '''''Specifies whether the driver performs an ID query on the device. When this parameter is set to VI_TRUE, NI-HSDIO ensures compatibility between the device and the driver.
        '''''
        '''''Defined Values:
        '''''- VI_TRUE(1) Perform ID query
        '''''- VI_FALSE(0) Skip ID query
        '''''
        '''''</param>
        '''''<param name="Reset_Instrument">
        '''''Specifies whether the driver resets the device during initialization of the session. Refer to the niHSDIO_reset function for more information on what happens during a device reset.
        '''''
        '''''Defined Values:
        '''''- VI_FALSE(0) - Do not reset device
        '''''- VI_TRUE(1) - Reset device
        '''''
        '''''NOTE: Resetting your device resets the ENTIRE device. Acquisition or generation operations in progress are aborted and cleared.
        '''''
        '''''</param>
        '''''<param name="Option_String">
        '''''Currently unused. Set this string to "".
        '''''</param>
        '''''<param name="Instrument_Handle">
        '''''Returns a VISession handle. Use this handle to identify the device in all subsequent instrument driver function calls related to your acquisition operation.
        '''''</param>
        Public Shared Function InitAcquisitionSession(ByVal Resource_Name As String, ByVal ID_Query As Boolean, ByVal Reset_Instrument As Boolean, ByVal Option_String As String) As niHSDIO
            Dim handle As System.IntPtr
            Dim pInvokeResult As Integer = PInvoke.InitAcquisitionSession(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Instrument), Option_String, handle)
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult)
            Try
                Return New niHSDIO(handle)
            Catch e As System.Exception
                PInvoke.close(handle)
                Throw e
            End Try
        End Function

        '''''<summary>
        '''''Creates a new generation session.  You can perform static and dynamic generation operations with this session.
        '''''
        '''''Creating a new session does not automatically tristate your front panel terminals or channels that might be driving voltages from previous sessions (refer to the niHSDIO_close function for more information on lines left driving after closing a session).
        '''''
        '''''Pass VI_TRUE to the resetInstrument parameter to place your device in a known start-up state when creating a new session. This action is equivalent to calling niHSDIO_reset, and it tristates the front panel terminals and channels.
        '''''
        '''''</summary>
        '''''<param name="Resource_Name">
        '''''Specifies the device name, for example "Dev1" where "Dev1" is a device name assigned by Measurement & Automation Explorer.
        '''''</param>
        '''''<param name="ID_Query">
        '''''Specifies whether the driver performs an ID query upon the device. When this parameter is set to VI_TRUE, the driver ensures compatibility between the device and driver.
        '''''
        '''''Defined Values:
        '''''- VI_TRUE(1) Perform ID query
        '''''- VI_FALSE(0) Skip ID query
        '''''
        '''''</param>
        '''''<param name="Reset_Instrument">
        '''''Specifies whether the driver resets the device during initialization of the session. Refer to the niHSDIO_reset function for more information on what happens during a device reset.
        '''''
        '''''Defined Values:
        '''''- VI_FALSE(0) - Do not reset device.
        '''''- VI_TRUE(1) - Reset device.
        '''''
        '''''NOTE: Resetting your device resets the ENTIRE device. Acquisition or generation operations in progress are aborted and cleared.
        '''''
        '''''
        '''''</param>
        '''''<param name="Option_String">
        '''''Currently unused.  Set this string to "".
        '''''</param>
        '''''<param name="Instrument_Handle">
        '''''Returns a VISession handle. Use this handle to identify the device in all subsequent instrument driver function calls related to your generation operation.
        '''''</param>
        Public Shared Function InitGenerationSession(ByVal Resource_Name As String, ByVal ID_Query As Boolean, ByVal Reset_Instrument As Boolean, ByVal Option_String As String) As niHSDIO
            Dim handle As System.IntPtr
            Dim pInvokeResult As Integer = PInvoke.InitGenerationSession(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Instrument), Option_String, handle)
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult)
            Try
                Return New niHSDIO(handle)
            Catch e As System.Exception
                PInvoke.close(handle)
                Throw e
            End Try
        End Function

        '''''<summary>
        '''''Creates and initializes a special NI-HSDIO external calibration session. The ViSession returned is an NI-HSDIO session that can be used during the calibration session.
        '''''
        '''''Multiple calls to this function return the same session ID. Calibration sessions are mutually exclusive with acquisition and generation sessions.
        '''''
        '''''</summary>
        '''''<param name="Resource_Name">
        '''''
        '''''</param>
        '''''<param name="Password">
        '''''The calibration password required to open an external calibration session to the device. 
        '''''
        '''''Default Value: "" 
        '''''</param>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from the function used to initialize the session.
        '''''</param>
        Public Shared Function InitExtCal(ByVal Resource_Name As String, ByVal Password As String) As niHSDIO
            Dim handle As System.IntPtr
            Dim pInvokeResult As Integer = PInvoke.InitExtCal(Resource_Name, Password, handle)
            PInvoke.TestForError(System.IntPtr.Zero, pInvokeResult)
            Try
                Return New niHSDIO(handle)
            Catch e As System.Exception
                PInvoke.close(handle)
                Throw e
            End Try
        End Function

        '''''<summary>
        '''''Configures the voltage levels for the data channels using a logic family.
        '''''
        '''''NOTE: Refer to the device documentation for descriptions of logic families and possible voltage restrictions.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from the function used to initialize the session.
        '''''
        '''''</param>
        '''''<param name="Channel_List">
        '''''Identifies channels to apply settings. Use "" or VI_NULL to specify all channels.
        '''''</param>
        '''''<param name="Logic_Family">
        '''''Specifies the logic family for the data voltage levels.
        '''''
        '''''Defined Values:
        '''''
        '''''-NIHSDIO_VAL_1_8V_LOGIC
        '''''-NIHSDIO_VAL_2_5V_LOGIC
        '''''-NIHSDIO_VAL_3_3V_LOGIC
        '''''-NIHSDIO_VAL_5_0V_LOGIC
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureDataVoltageLogicFamily(ByVal Channel_List As String, ByVal Logic_Family As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureDataVoltageLogicFamily(Me._handle, Channel_List, Logic_Family)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the voltage levels of the data channels using the specified high and low levels.
        '''''
        '''''NOTE: Refer to the device documentation for possible voltage restrictions.
        '''''
        '''''NOTE: If you are using an NI 654x device for generation sessions, set High_Level to the appropriate logic family value  and set How_Level to 0. For acquisition sessions with the 
        '''''NI 654x, select the same value for High_Level and Low_Level from the following list: 0.9 V, 1.25 V, or 1.65 V.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from the function used to initialize the session.
        '''''
        '''''</param>
        '''''<param name="Channel_List">
        '''''Identifies channels to apply settings. Use "" or VI_NULL to specify all channels.
        '''''</param>
        '''''<param name="Low_Level">
        '''''Specifies what voltage identifies logic low level.
        '''''
        '''''</param>
        '''''<param name="High_Level">
        '''''Specifies what voltage identifies logic high level.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureDataVoltageCustomLevels(ByVal Channel_List As String, ByVal Low_Level As Double, ByVal High_Level As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureDataVoltageCustomLevels(Me._handle, Channel_List, Low_Level, High_Level)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the voltage levels for the trigger channels using a logic family.
        '''''
        '''''NOTE: Refer to the device documentation for descriptions of logic families and possible voltage restrictions.
        '''''
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from the function used to initialize the session.
        '''''
        '''''</param>
        '''''<param name="Logic_Family">
        '''''Specifies the logic family for the trigger voltage levels.
        '''''
        '''''Defined Values:
        '''''
        '''''-NIHSDIO_VAL_5_0V_LOGIC
        '''''-NIHSDIO_VAL_3_3V_LOGIC
        '''''-NIHSDIO_VAL_2_5V_LOGIC
        '''''-NIHSDIO_VAL_1_8V_LOGIC
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureTriggerVoltageLogicFamily(ByVal Logic_Family As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureTriggerVoltageLogicFamily(Me._handle, Logic_Family)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the voltage levels of the trigger channels using user-defined high and low levels.
        '''''
        '''''NOTE: Refer to the device documentation for possible voltage restrictions.
        '''''
        '''''NOTE: If you are using an NI 654x device for generation sessions, set High_Level to the appropriate logic family value and set How_Level to 0. For acquisition sessions with the 
        '''''NI 654x, select the same value for High_Level and Low_Level from the following list: 0.9 V, 1.25 V, or 1.65 V.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from the function used to initialize the session.
        '''''
        '''''</param>
        '''''<param name="Low_Level">
        '''''Specifies what voltage identifies logic low level.
        '''''
        '''''</param>
        '''''<param name="High_Level">
        '''''Specifies what voltage identifies logic high level.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureTriggerVoltageCustomLevels(ByVal Low_Level As Double, ByVal High_Level As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureTriggerVoltageCustomLevels(Me._handle, Low_Level, High_Level)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the voltage levels for the event channels using a logic family.
        '''''
        '''''NOTE: Refer to the device documentation for descriptions of logic families and possible voltage restrictions.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from the function used to initialize the session.
        '''''
        '''''</param>
        '''''<param name="Logic_Family">
        '''''Specifies the logic family for the event voltage levels.
        '''''
        '''''Defined Values:
        '''''
        '''''-NIHSDIO_VAL_1_8V_LOGIC
        '''''-NIHSDIO_VAL_2_5V_LOGIC
        '''''-NIHSDIO_VAL_3_3V_LOGIC
        '''''-NIHSDIO_VAL_5_0V_LOGIC
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureEventVoltageLogicFamily(ByVal Logic_Family As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureEventVoltageLogicFamily(Me._handle, Logic_Family)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the voltage levels of the event channels using user-defined high and low levels.
        '''''
        '''''NOTE: Refer to the device documentation for possible voltage restrictions.
        '''''
        '''''NOTE: If you are using an NI 654x device for generation sessions, set High_Level to the appropriate logic family value and set How_Level to 0. For acquisition sessions with the 
        '''''NI 654x, select the same value for High_Level and Low_Level from the following list: 0.9 V, 1.25 V, or 1.65 V.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from the function used to initialize the session.
        '''''
        '''''</param>
        '''''<param name="Low_Level">
        '''''Specifies what voltage identifies logic low level.
        '''''
        '''''</param>
        '''''<param name="High_Level">
        '''''Specifies what voltage identifies logic high level.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureEventVoltageCustomLevels(ByVal Low_Level As Double, ByVal High_Level As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureEventVoltageCustomLevels(Me._handle, Low_Level, High_Level)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures channels for dynamic acquisition (if vi is an acquisition session) or dynamic generation (if vi is a generation session).
        '''''
        '''''NOTE: A channel cannot be assigned to static generation and dynamic generation at the same time.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Channel_List">
        '''''This string identifies which channels are reserved for dynamic operation.
        '''''
        '''''Valid Syntax:
        '''''"0-19" or "0-15,16-19" or "0-18,19"
        '''''"" (empty string) or VI_NULL to specify all channels
        '''''"none" to unassign all channels
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function AssignDynamicChannels(ByVal Channel_List As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.AssignDynamicChannels(Me._handle, Channel_List)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Commits any pending attributes to hardware and starts the dynamic operation (refer to niHSDIO_CommitDynamic for more information on committing).
        '''''
        '''''For an generation operation with a Start trigger configured, calling niHSDIO_Initiate causes the channels to go to their Initial states (refer to niHSDIO_ConfigureInitialState for more information on Initial states).
        '''''
        '''''This function is valid only for dynamic operations (acquisition or generation). It is not valid for static operations.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function Initiate() As Integer
            Dim pInvokeResult As Integer = PInvoke.Initiate(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Call this function to pause execution of your program until the dynamic data operation is completed or the function returns a timeout error. niHSDIO_WaitUntilDone is a blocking function that periodically checks the operation status. It returns control to the calling program if the operation completes successfully or an error occurs (including a timeout error).
        '''''
        '''''This function is most useful for finite data operations that you expect to complete within a certain time.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Max_Time_Milliseconds">
        '''''This parameter specifies the number of milliseconds to allow the function to complete before returning. If the specified time elapses before the data operation has completed, the function returns a timeout error.
        '''''
        '''''- Setting a value of 0 causes the function to return immediately. This setting can be useful to manually poll for hardware errors after a data operation has been initiated. If no other error has occurred and the data operation is still not complete, the function returns a timeout error.
        '''''
        '''''- Setting a value of -1 causes the function to never timeout. Be careful not to use this value during a continuous operation, as it will never return unless a HW error occurs. Perform a manual device reset from Measurement and Automation Explorer if you get stuck in this state or use niHSDIO_reset or niHSDIO_ResetDevice from the other session of the device.
        '''''
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function WaitUntilDone(ByVal Max_Time_Milliseconds As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.WaitUntilDone(Me._handle, Max_Time_Milliseconds)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Stops a running dynamic session.  This function is generally not required on finite data operations, as they complete on their own after the last data point is generated or acquired.  This function is generally required for continuous operations or if you wish to interrupt a finite operation before it is completed.
        '''''
        '''''This function is valid for dynamic operations (acquisition or generation) only.  It is not valid for static operations.
        '''''
        '''''NOTE: To avoid receiving hardware clocking errors when reconfiguring an external clock, explicitly call the niHSDIO_Abort function after your finite operation has completed before performing any clocking reconfiguration.  An external clock that stops sending pulses to the device (even after a finite operation has completed) may cause NI-HSDIO to return an error, stating that the clock became unlocked, if the device has not implicitly aborted yet.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function Abort() As Integer
            Dim pInvokeResult As Integer = PInvoke.Abort(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the acquisition size, including the number of acquired records and the minimum record size.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Samples_Per_Record">
        '''''Sets the number of samples to be acquired per record. If you need pre- and post-trigger points, configure a Reference trigger and specify the number of pretrigger points.
        '''''</param>
        '''''<param name="Number_Of_Records">
        '''''Sets how many records are acquired. Currently this value must be set to 1.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureAcquisitionSize(ByVal Samples_Per_Record As Integer, ByVal Number_Of_Records As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureAcquisitionSize(Me._handle, Samples_Per_Record, Number_Of_Records)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Selects between acquiring high/low data or valid/invalid data during a static or dynamic acquisition operation.
        '''''
        '''''Select High or Low mode to get logic high or logic low values. Select Valid or Invalid mode to determine if the signal is within the specified voltage range (above data voltage low level but below data voltage high level) or outside the range (below data voltage low level or above data voltage high level). Refer to the Data Interpretation topic in the NI Digital Waveform Generator/Analyzer Help to understand how data is returned to you.
        '''''
        '''''NOTE: NI 654x/656x devices only support the High or Low mode of data interpretation. NI-HSDIO returns an error if you select Valid or Invalid mode for an acquisition with these devices.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Channel_List">
        '''''Identifies channels to apply settings. Use "" or VI_NULL to specify all channels.
        '''''</param>
        '''''<param name="Data_Interpretation">
        '''''Selects the data interpretation mode.
        '''''
        '''''Defined Values:
        '''''
        '''''-   NIHSDIO_VAL_HIGH_OR_LOW - Data read represents logical values (logic high or logic low)
        '''''
        '''''-   NIHSDIO_VAL_VALID_OR_INVALID - Data read represents whether channel data is within the specified voltage range.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureDataInterpretation(ByVal Channel_List As String, ByVal Data_Interpretation As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureDataInterpretation(Me._handle, Channel_List, Data_Interpretation)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Initiates a waveform acquisition on channels enabled for dynamic acquisition, waits until it acquires the number of samples in Samples_To_Read, and returns the acquired binary data.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Samples_To_Read">
        '''''Specifies the number of samples to fetch.
        '''''
        '''''</param>
        '''''<param name="Max_Time_Milliseconds">
        '''''Specifies in milliseconds how long to allow the function to complete before returning a timeout error.
        '''''
        '''''A value of 0 causes the function to return immediately with up to the number of samples specified in Samples_To_Read. If you set Max_Time_Milliseconds to a value other than 0, and timeout occurs before all the samples are acquired, you receive a timeout error. If you specify a value for Samples_To_Read that is greater than the number of samples in the device memory, NI-HSDIO returns the available samples after Max_Time_Milliseconds. A value of -1 causes the function to never time out.
        '''''
        '''''</param>
        '''''<param name="Number_Of_Samples_Read">
        '''''Returns the number of samples that were successfully fetched and transferred into data[].
        '''''</param>
        '''''<param name="Data">
        '''''Returns the preallocated array where acquired samples are written.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ReadWaveformU32(ByVal Samples_To_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByRef Number_Of_Samples_Read As Integer, ByVal Data() As UInteger) As Integer
            Dim pInvokeResult As Integer = PInvoke.ReadWaveformU32(Me._handle, Samples_To_Read, Max_Time_Milliseconds, Number_Of_Samples_Read, Data)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Transfers acquired binary data from onboard memory to PC memory.  The data was acquired to onboard memory previously by calling the niHSDIO_Initiate function.
        '''''
        '''''If the number of samples specified in Samples_To_Read is still not available after the number of milliseconds specified in Max_Time_Milliseconds, this function returns no data with a timeout error.
        '''''
        '''''The fetch position can be modified by using niHSDIO_SetAttributeViInt32 and the NIHSDIO_ATTR_FETCH_RELATIVE_TO or NIHSDIO_ATTR_FETCH_OFFSET attributes. The default value for NIHSDIO_ATTR_FETCH_RELATIVE_TO is NIHSDIO_VAL_CURRENT_READ_POSITION. The default value for NIHSDIO_ATTR_FETCH_OFFSET is 0.
        '''''
        '''''Calling this function is not necessary if you use the niHSDIO_ReadWaveformU32 function, as the fetch is performed as part of that function.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Samples_To_Read">
        '''''Specifies the number of samples to fetch.
        '''''
        '''''</param>
        '''''<param name="Max_Time_Milliseconds">
        '''''Specifies in milliseconds how long to allow the function to complete before returning a timeout error.
        '''''
        '''''A value of 0 causes the function to return immediately with up to the number of samples specified in Samples_To_Read. If you set Max_Time_Milliseconds to a value other than 0, and timeout occurs before all the samples are acquired, you receive a timeout error. If you specify a value for Samples_To_Read that is greater than the number of samples in the device memory, NI-HSDIO returns the available samples after max time milliseconds. A value of -1 causes the function to never time out.
        '''''
        '''''</param>
        '''''<param name="Number_Of_Samples_Read">
        '''''Returns the number of samples that were successfully fetched and transferred into data[].
        '''''</param>
        '''''<param name="Data">
        '''''Returns the preallocated array where acquired samples are written.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function FetchWaveformU32(ByVal Samples_To_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByRef Number_Of_Samples_Read As Integer, ByVal Data() As UInteger) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchWaveformU32(Me._handle, Samples_To_Read, Max_Time_Milliseconds, Number_Of_Samples_Read, Data)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Initiates a waveform acquisition on channels enabled for dynamic acquisition, waits until it acquires the number of samples in Samples_To_Read, and returns the acquired binary data.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Samples_To_Read">
        '''''Specifies the number of samples to fetch.
        '''''
        '''''</param>
        '''''<param name="Max_Time_Milliseconds">
        '''''Specifies in milliseconds how long to allow the function to complete before returning a timeout error.
        '''''
        '''''A value of 0 causes the function to return immediately with up to the number of samples specified in samples_To_Read. If you set Max_Time_Milliseconds to a value other than 0, and timeout occurs before all the samples are acquired, you receive a timeout error. If you specify a value for Samples_To_Read that is greater than the number of samples in the device memory, NI-HSDIO returns the available samples after Max_Time_Milliseconds. A value of -1 causes the function to never time out.
        '''''
        '''''</param>
        '''''<param name="Number_Of_Samples_Read">
        '''''Returns the number of samples that were successfully fetched and transferred into data[].
        '''''</param>
        '''''<param name="Data">
        '''''Returns the preallocated array where acquired samples are written.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ReadWaveformU16(ByVal Samples_To_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByRef Number_Of_Samples_Read As Integer, ByVal Data() As Short) As Integer
            Dim pInvokeResult As Integer = PInvoke.ReadWaveformU16(Me._handle, Samples_To_Read, Max_Time_Milliseconds, Number_Of_Samples_Read, Data)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Transfers acquired binary data from onboard memory to PC memory.  The data was acquired to onboard memory previously by calling the niHSDIO_Initiate function.
        '''''
        '''''If the number of samples specified in Samples_To_Read is still not available after the number of milliseconds specified in Max_Time_Milliseconds, this function returns no data with a timeout error.
        '''''
        '''''The fetch position can be modified by using niHSDIO_SetAttributeViInt32 and the NIHSDIO_ATTR_FETCH_RELATIVE_TO or NIHSDIO_ATTR_FETCH_OFFSET attributes. The default value for NIHSDIO_ATTR_FETCH_RELATIVE_TO is NIHSDIO_VAL_CURRENT_READ_POSITION. The default value for NIHSDIO_ATTR_FETCH_OFFSET is 0.
        '''''
        '''''Calling this function is not necessary if you use the niHSDIO_ReadWaveformU16 function, as the fetch is performed as part of that function.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Samples_To_Read">
        '''''Specifies the number of samples to fetch.
        '''''
        '''''</param>
        '''''<param name="Max_Time_Milliseconds">
        '''''Specifies in milliseconds how long to allow the function to complete before returning a timeout error.
        '''''
        '''''A value of 0 causes the function to return immediately with up to the number of samples specified in Samples_To_Read. If you set Max_Time_Milliseconds to a value other than 0, and timeout occurs before all the samples are acquired, you receive a timeout error. If you specify a value for Samples_To_Read that is greater than the number of samples in the device memory, NI-HSDIO returns the available samples after max time milliseconds. A value of -1 causes the function to never time out.
        '''''
        '''''</param>
        '''''<param name="Number_Of_Samples_Read">
        '''''Returns the number of samples that were successfully fetched and transferred into data[].
        '''''</param>
        '''''<param name="Data">
        '''''Returns the preallocated array where acquired samples are written.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function FetchWaveformU16(ByVal Samples_To_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByRef Number_Of_Samples_Read As Integer, ByVal Data() As Short) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchWaveformU16(Me._handle, Samples_To_Read, Max_Time_Milliseconds, Number_Of_Samples_Read, Data)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Initiates a waveform acquisition on channels enabled for dynamic acquisition, waits until it acquires the number of samples in Samples_To_Read, and returns the acquired binary data.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Samples_To_Read">
        '''''Specifies the number of samples to fetch.
        '''''
        '''''</param>
        '''''<param name="Max_Time_Milliseconds">
        '''''Specifies in milliseconds how long to allow the function to complete before returning a timeout error.
        '''''
        '''''A value of 0 causes the function to return immediately with up to the number of samples specified in samples_To_Read. If you set Max_Time_Milliseconds to a value other than 0, and timeout occurs before all the samples are acquired, you receive a timeout error. If you specify a value for Samples_To_Read that is greater than the number of samples in the device memory, NI-HSDIO returns the available samples after Max_Time_Milliseconds. A value of -1 causes the function to never time out.
        '''''
        '''''</param>
        '''''<param name="Number_Of_Samples_Read">
        '''''Returns the number of samples that were successfully fetched and transferred into data[].
        '''''</param>
        '''''<param name="Data">
        '''''Returns the preallocated array where acquired samples are written.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ReadWaveformU8(ByVal Samples_To_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByRef Number_Of_Samples_Read As Integer, ByVal Data() As Byte) As Integer
            Dim pInvokeResult As Integer = PInvoke.ReadWaveformU8(Me._handle, Samples_To_Read, Max_Time_Milliseconds, Number_Of_Samples_Read, Data)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Transfers acquired binary data from onboard memory to PC memory.  The data was acquired to onboard memory previously by calling the niHSDIO_Initiate function.
        '''''
        '''''If the number of samples specified in Samples_To_Read is still not available after the number of milliseconds specified in Max_Time_Milliseconds, this function returns no data with a timeout error.
        '''''
        '''''The fetch position can be modified by using niHSDIO_SetAttributeViInt32 and the NIHSDIO_ATTR_FETCH_RELATIVE_TO or NIHSDIO_ATTR_FETCH_OFFSET attributes. The default value for NIHSDIO_ATTR_FETCH_RELATIVE_TO is NIHSDIO_VAL_CURRENT_READ_POSITION. The default value for NIHSDIO_ATTR_FETCH_OFFSET is 0.
        '''''
        '''''Calling this function is not necessary if you use the niHSDIO_ReadWaveformU8 function, as the fetch is performed as part of that function.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Samples_To_Read">
        '''''Specifies the number of samples to fetch.
        '''''
        '''''</param>
        '''''<param name="Max_Time_Milliseconds">
        '''''Specifies in milliseconds how long to allow the function to complete before returning a timeout error.
        '''''
        '''''A value of 0 causes the function to return immediately with up to the number of samples specified in Samples_To_Read. If you set Max_Time_Milliseconds to a value other than 0, and timeout occurs before all the samples are acquired, you receive a timeout error. If you specify a value for Samples_To_Read that is greater than the number of samples in the device memory, NI-HSDIO returns the available samples after max time milliseconds. A value of -1 causes the function to never time out.
        '''''
        '''''</param>
        '''''<param name="Number_Of_Samples_Read">
        '''''Returns the number of samples that were successfully fetched and transferred into data[].
        '''''</param>
        '''''<param name="Data">
        '''''Returns the preallocated array where acquired samples are written.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function FetchWaveformU8(ByVal Samples_To_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByRef Number_Of_Samples_Read As Integer, ByVal Data() As Byte) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchWaveformU8(Me._handle, Samples_To_Read, Max_Time_Milliseconds, Number_Of_Samples_Read, Data)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Initiates a multirecord acquisition and returns the acquired waveform as a two-dimensional array of unsigned 32-bit data.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Samples_To_Read">
        '''''Specifies the number of samples to fetch.
        '''''</param>
        '''''<param name="Max_Time_Milliseconds">
        '''''Specifies in milliseconds how long to allow the function to complete before returning a timeout error.
        '''''</param>
        '''''<param name="Starting_Record">
        '''''Specifies the first record you want to read.
        '''''</param>
        '''''<param name="Records_To_Read">
        '''''The number of records you want to read.
        '''''</param>
        '''''<param name="Waveform_Data">
        '''''Returns the array of waveform data that contains the records to read.
        '''''</param>
        '''''<param name="Waveform_Info">
        '''''Returns information about the records. This parameter includes an absolute timestamp, relative timestamp, the number of samples acquired, and the dT of the waveform.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''</returns>
        Public Function ReadMultiRecordU32(ByVal Samples_To_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByVal Starting_Record As Integer, ByVal Records_To_Read As Integer, ByVal Waveform_Data() As UInteger, ByVal Waveform_Info As nihsdio_wfminfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.ReadMultiRecordU32(Me._handle, Samples_To_Read, Max_Time_Milliseconds, Starting_Record, Records_To_Read, Waveform_Data, Waveform_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Fetches the data as a two-dimensional array of unsigned 32-bit integers and returns the number of samples read.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Samples_To_Read">
        '''''Specifies the number of samples to fetch.
        '''''</param>
        '''''<param name="Max_Time_Milliseconds">
        '''''Specifies in milliseconds how long to allow the function to complete before returning a timeout error.
        '''''</param>
        '''''<param name="Starting_Record">
        '''''Specifies the first record you want to read.
        '''''</param>
        '''''<param name="Records_To_Read">
        '''''Specifies the number of records you want to read.
        '''''</param>
        '''''<param name="Waveform_Data">
        '''''Returns the array of waveform data that contains the records to read.
        '''''</param>
        '''''<param name="Waveform_Info">
        '''''Returns information about the records. This parameter includes an absolute timestamp, relative timestamp, the number of samples acquired, and the dT of the waveform.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''</returns>
        Public Function FetchMultiRecordU32(ByVal Samples_To_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByVal Starting_Record As Integer, ByVal Records_To_Read As Integer, ByVal Waveform_Data() As UInteger, ByVal Waveform_Info As nihsdio_wfminfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchMultiRecordU32(Me._handle, Samples_To_Read, Max_Time_Milliseconds, Starting_Record, Records_To_Read, Waveform_Data, Waveform_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Initiates a multirecord acquisition, and returns the acquired waveform as a two-dimensional array of unsigned 16-bit data.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Max_Time_Milliseconds">
        '''''Specifies in milliseconds how long to allow the function to complete before returning a timeout error.
        '''''</param>
        '''''<param name="Samples_To_Read">
        '''''Specifies the number of samples to fetch.
        '''''</param>
        '''''<param name="Starting_Record">
        '''''Specifies the first record you want to read.
        '''''</param>
        '''''<param name="Records_To_Read">
        '''''Specifies the number of records you want to read.
        '''''</param>
        '''''<param name="Waveform_Data">
        '''''Returns the array of waveform data that contains the records to read.
        '''''</param>
        '''''<param name="Waveform_Info">
        '''''Returns information about the records. This parameter includes an absolute timestamp, relative timestamp, the number of samples acquired, and the dT of the waveform.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''</returns>
        Public Function ReadMultiRecordU16(ByVal Max_Time_Milliseconds As Integer, ByVal Samples_To_Read As Integer, ByVal Starting_Record As Integer, ByVal Records_To_Read As Integer, ByVal Waveform_Data() As Short, ByVal Waveform_Info As nihsdio_wfminfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.ReadMultiRecordU16(Me._handle, Max_Time_Milliseconds, Samples_To_Read, Starting_Record, Records_To_Read, Waveform_Data, Waveform_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Fetches the data as a two-dimensional array of unsigned 16-bit integers and returns the number of samples read.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Max_Time_Milliseconds">
        '''''Specifies in milliseconds how long to allow the function to complete before returning a timeout error.
        '''''</param>
        '''''<param name="Samples_To_Read">
        '''''Specifies the number of samples to fetch.
        '''''</param>
        '''''<param name="Starting_Record">
        '''''Specifies the first record you want to read.
        '''''</param>
        '''''<param name="Records_To_Read">
        '''''Specifies the number of records you want to read.
        '''''</param>
        '''''<param name="Waveform_Data">
        '''''Returns the array of waveform data that contains the records to read.
        '''''</param>
        '''''<param name="Waveform_Info">
        '''''Returns information about the records. This parameter includes an absolute timestamp, relative timestamp, the number of samples acquired, and the dT of the waveform.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''</returns>
        Public Function FetchMultiRecordU16(ByVal Max_Time_Milliseconds As Integer, ByVal Samples_To_Read As Integer, ByVal Starting_Record As Integer, ByVal Records_To_Read As Integer, ByVal Waveform_Data() As Short, ByVal Waveform_Info As nihsdio_wfminfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchMultiRecordU16(Me._handle, Max_Time_Milliseconds, Samples_To_Read, Starting_Record, Records_To_Read, Waveform_Data, Waveform_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Initiates a multirecord acquisition, and returns the acquired waveform as a two-dimensional array of unsigned 8-bit data.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Samples_To_Read">
        '''''Specifies the number of samples to fetch.
        '''''</param>
        '''''<param name="Max_Time_Milliseconds">
        '''''Specifies in milliseconds how long to allow the function to complete before returning a timeout error.
        '''''</param>
        '''''<param name="Starting_Record">
        '''''Specifies the first record you want to read.
        '''''</param>
        '''''<param name="Records_To_Read">
        '''''Specifies the number of records you want to read.
        '''''</param>
        '''''<param name="Waveform_Data">
        '''''Returns the array of waveform data that contains the records to read.
        '''''</param>
        '''''<param name="Waveform_Info">
        '''''Returns information about the records. This parameter includes an absolute timestamp, relative timestamp, the number of samples acquired, and the dT of the waveform.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''</returns>
        Public Function ReadMultiRecordU8(ByVal Samples_To_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByVal Starting_Record As Integer, ByVal Records_To_Read As Integer, ByVal Waveform_Data() As Byte, ByVal Waveform_Info As nihsdio_wfminfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.ReadMultiRecordU8(Me._handle, Samples_To_Read, Max_Time_Milliseconds, Starting_Record, Records_To_Read, Waveform_Data, Waveform_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Fetches the data as a two-dimensional array of unsigned 8-bit integers and returns the number of samples read.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Samples_To_Read">
        '''''Specifies the number of samples to fetch.
        '''''</param>
        '''''<param name="Max_Time_Milliseconds">
        '''''Specifies in milliseconds how long to allow the function to complete before returning a timeout error.
        '''''</param>
        '''''<param name="Starting_Record">
        '''''Specifies the first record you want to read.
        '''''</param>
        '''''<param name="Records_To_Read">
        '''''Specifies the number of records you want to read.
        '''''</param>
        '''''<param name="Waveform_Data">
        '''''Returns the array of waveform data that contains the records to read.
        '''''</param>
        '''''<param name="Waveform_Info">
        '''''Returns information about the records. This parameter includes an absolute timestamp, relative timestamp, the number of samples acquired, and the dT of the waveform.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''</returns>
        Public Function FetchMultiRecordU8(ByVal Samples_To_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByVal Starting_Record As Integer, ByVal Records_To_Read As Integer, ByVal Waveform_Data() As Byte, ByVal Waveform_Info As nihsdio_wfminfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchMultiRecordU8(Me._handle, Samples_To_Read, Max_Time_Milliseconds, Starting_Record, Records_To_Read, Waveform_Data, Waveform_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Transfers acquired waveform data from device memory directly to PC memory allocated by a Direct DMA-compatible device.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Max_Time_Milliseconds">
        '''''Specifies in milliseconds how long to allow the function to complete before returning a timeout error.
        '''''</param>
        '''''<param name="Samples_To_Read">
        '''''Specifies the number of samples to fetch.
        '''''</param>
        '''''<param name="Buffer_Size">
        '''''Specifies the size (in bytes) of the buffer in memory at which to transfer acquired data.
        '''''</param>
        '''''<param name="Buffer_Address">
        '''''Specifies the location of the buffer in memory at which to transfer acquired data.
        '''''</param>
        '''''<param name="Waveform_Info">
        '''''Returns information about the records. This parameter includes an absolute timestamp, relative timestamp, the number of samples acquired, and the dT of the waveform.
        '''''</param>
        '''''<param name="Offset_to_First_Sample">
        '''''Returns the offset of the first sample acquired within the specified buffer. Data is transfered from device memory in 128 bytes increments, so the first sample of the acquired data typically occurs at some offset from the start of the buffer when using a Reference trigger.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''</returns>
        Public Function FetchWaveformDirectDMA(ByVal Max_Time_Milliseconds As Integer, ByVal Samples_To_Read As Integer, ByVal Buffer_Size As UInteger, ByVal Buffer_Address As System.IntPtr, ByVal Waveform_Info As nihsdio_wfminfo, ByVal Offset_to_First_Sample As UInteger) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchWaveformDirectDMA(Me._handle, Max_Time_Milliseconds, Samples_To_Read, Buffer_Size, Buffer_Address, Waveform_Info, Offset_to_First_Sample)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Returns the sample error information from a hardware comparison operation. 
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Sample_Errors_to_Read">
        '''''Specifies the number of sample errors to fetch.
        '''''</param>
        '''''<param name="Max_Time_Milliseconds">
        '''''Specifies in milliseconds how long to allow the function to complete before returning a timeout error.
        '''''
        '''''A value of 0 causes the function to return immediately with up to the number of samples specified in Samples_To_Read. If you set Max_Time_Milliseconds to a value other than 0, and timeout occurs before all the samples are acquired, you receive a timeout error. If you specify a value for Samples_To_Read that is greater than the number of samples in the device memory, NI-HSDIO returns the available samples after max time milliseconds. A value of -1 causes the function to never timeout.
        '''''
        '''''Default Value: 10000
        '''''</param>
        '''''<param name="Number_Of_Samples_Error_Read">
        '''''Returns the total number of sample errors read from device memory.
        '''''</param>
        '''''<param name="Error_Sample_Numbers">
        '''''Returned array which indicates the number of samples with errors.
        '''''</param>
        '''''<param name="Error_Bits">
        '''''Returns the bit numbers of the data within the samples with errors. Please note, the sampleNumber[i] and errorBits[i] correspond to one another
        '''''
        '''''</param>
        '''''<param name="Error_Repeat_Counts">
        '''''Returns the number of times that error was repeated.
        '''''</param>
        '''''<param name="Reserved_1">
        '''''Reserved filed. Use NULL.
        '''''</param>
        '''''<param name="Reserved_2">
        '''''Reserved filed. Use NULL.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function HWC_FetchSampleErrors(ByVal Sample_Errors_to_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByRef Number_Of_Samples_Error_Read As Integer, ByVal Error_Sample_Numbers() As Double, ByVal Error_Bits() As UInteger, ByVal Error_Repeat_Counts() As UInteger, ByRef Reserved_1 As UInteger, ByRef Reserved_2 As UInteger) As Integer
            Dim pInvokeResult As Integer = PInvoke.HWC_FetchSampleErrors(Me._handle, Sample_Errors_to_Read, Max_Time_Milliseconds, Number_Of_Samples_Error_Read, Error_Sample_Numbers, Error_Bits, Error_Repeat_Counts, Reserved_1, Reserved_2)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Transfers waveform data from PC memory to onboard memory. Supported devices for this function depend on the data width for your device, not on the number of assigned dynamic channels. This function may be used when the data width is 4.
        '''''
        '''''If you specify a Waveform_Name not already allocated on the device, the appropriate amount of onboard memory is allocated (if available) and the data is stored in that new location.
        '''''
        '''''Data is always written to memory starting at the current write position of the waveform. A new waveform's write position is the start of the allocated memory. Calling niHSDIO_WriteNamedWaveformU32 moves the next write position to the end of the data just written. Thus, subsequent calls to niHSDIO_WriteNamedWaveformU32 append data to the end of previously written data. You may also manually change the write position by calling niHSDIO_SetNamedWaveformNextWritePosition. If you try to write past the end of the allocated space, NI-HSDIO returns an error. 
        '''''
        '''''Waveforms are stored contiguously in onboard memory.  You cannot resize an existing named waveform. Instead, delete the existing waveform using niHSDIO_DeleteNamedWaveform and then recreate it with the new size using the same name.
        '''''
        '''''This function calls niHSDIO_CommitDynamic - all pending attributes are committed to hardware.
        '''''
        '''''When you explicitly call niHSDIO_AllocateNamedWaveform and write waveforms using multiple niHSDIO_WriteNamedWaveformU32 calls, each waveform block written must be a multiple of 32 samples for the NI 654x/655x devices or a multiple of 64 samples 
        '''''for the NI 656x devices (128 samples if the NI 656x is in 
        '''''DDR mode).
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Waveform_Name">
        '''''Specifies a string representing the name to associate with the allocated waveform memory.
        '''''</param>
        '''''<param name="Samples_To_Write">
        '''''Specifies the number of samples in data to be written to onboard memory.
        '''''
        '''''</param>
        '''''<param name="Data">
        '''''Specifies the waveform data.
        '''''
        '''''If you want to use direct DMA to write your waveform from onboard memory, pass the memory address (pointer value) of the region so that you write within the direct DMA window.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function WriteNamedWaveformU32(ByVal Waveform_Name As String, ByVal Samples_To_Write As Integer, ByVal Data() As UInteger) As Integer
            Dim pInvokeResult As Integer = PInvoke.WriteNamedWaveformU32(Me._handle, Waveform_Name, Samples_To_Write, Data)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Transfers waveform data from PC memory to onboard memory. Supported devices for this function depend on the data width for your device, not on the number of assigned dynamic channels. This function may be used when the data width is 2.
        '''''
        '''''If you specify a waveformName not already allocated on the device, the appropriate amount of onboard memory is allocated (if available) and the data is stored in that new location.
        '''''
        '''''Data is always written to memory starting at the current write position of the waveform. A new waveform's write position is the start of the allocated memory. Calling this function moves the next write position to the end of the data just written. Thus, subsequent calls to this function append data to the end of previously written data. You may also manually change the write position by calling niHSDIO_SetNamedWaveformNextWritePosition. If you try to write past the end of the allocated space, NI-HSDIO returns an error. 
        '''''
        '''''Waveforms are stored contiguously in onboard memory.  You cannot resize an existing named waveform. Instead, delete the existing waveform using niHSDIO_DeleteNamedWaveform and then recreate it with the new size using the same name.
        '''''
        '''''This function calls niHSDIO_CommitDynamic - all pending attributes are committed to hardware.
        '''''
        '''''When you explicitly call niHSDIO_AllocateNamedWaveform and write waveforms using multiple niHSDIO_WriteNamedWaveformU16 calls, each waveform block written must be a multiple of 32 samples for the NI 654X/655X devices or a multiple of 64 samples 
        '''''for the NI 656X devices (128 samples if the NI 656X is in 
        '''''DDR mode).
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Waveform_Name">
        '''''Specifies a string representing the name to associate with the allocated waveform memory.
        '''''</param>
        '''''<param name="Samples_To_Write">
        '''''Specifies the number of samples in data to be written to onboard memory.
        '''''
        '''''</param>
        '''''<param name="Data">
        '''''Specifies the waveform data.
        '''''
        '''''If you want to use direct DMA to write your waveform from onboard memory, pass the memory address (pointer value) of the region so that you write within the direct DMA window.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function WriteNamedWaveformU16(ByVal Waveform_Name As String, ByVal Samples_To_Write As Integer, ByVal Data() As Short) As Integer
            Dim pInvokeResult As Integer = PInvoke.WriteNamedWaveformU16(Me._handle, Waveform_Name, Samples_To_Write, Data)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Transfers waveform data from PC memory to onboard memory. Supported devices for this function depend on the data width for your device, not on the number of assigned dynamic channels. This function may be used when the data width is 1.
        '''''
        '''''If you specify a waveformName not already allocated on the device, the appropriate amount of onboard memory is allocated (if available) and the data is stored in that new location.
        '''''
        '''''Data is always written to memory starting at the current write position of the waveform. A new waveform's write position is the start of the allocated memory. Calling this function moves the next write position to the end of the data just written. Thus, subsequent calls to this function append data to the end of previously written data. You may also manually change the write position by calling niHSDIO_SetNamedWaveformNextWritePosition. If you try to write past the end of the allocated space, NI-HSDIO returns an error. 
        '''''
        '''''Waveforms are stored contiguously in onboard memory.  You cannot resize an existing named waveform. Instead, delete the existing waveform using niHSDIO_DeleteNamedWaveform and then recreate it with the new size using the same name.
        '''''
        '''''This function calls niHSDIO_CommitDynamic - all pending attributes are committed to hardware.
        '''''
        '''''When you explicitly call niHSDIO_AllocateNamedWaveform and write waveforms using multiple niHSDIO_WriteNamedWaveformU8 calls, each waveform block written must be a multiple of 32 samples for the NI 654X/655X devices or a multiple of 64 samples 
        '''''for the NI 656X devices (128 samples if the NI 656X is in 
        '''''DDR mode).
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Waveform_Name">
        '''''Specifies a string representing the name to associate with the allocated waveform memory.
        '''''</param>
        '''''<param name="Samples_To_Write">
        '''''Specifies the number of samples in data to be written to onboard memory.
        '''''
        '''''</param>
        '''''<param name="Data">
        '''''Specifies the waveform data.
        '''''
        '''''If you want to use direct DMA to write your waveform from onboard memory, pass the memory address (pointer value) of the region so that you write within the direct DMA window.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function WriteNamedWaveformU8(ByVal Waveform_Name As String, ByVal Samples_To_Write As Integer, ByVal Data() As Byte) As Integer
            Dim pInvokeResult As Integer = PInvoke.WriteNamedWaveformU8(Me._handle, Waveform_Name, Samples_To_Write, Data)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Transfers multistate digital waveforms from PC memory to onboard memory. Each element of data[] uses one byte per channel per sample. The supported values are defined in niHSDIO.h.
        '''''
        '''''If you specify a waveformName not already allocated on the device, the appropriate amount of onboard memory is allocated (if available), and the data is stored in that new location.
        '''''
        '''''Data is always written to memory starting at the current write position of the waveform. A new waveform's write position is the start of the allocated memory. Calling this function moves the next write position to the end of the data just written. Thus, subsequent calls to this function append data to the end of previously written data. You can manually change the write position by calling niHSDIO_SetNamedWaveformNextWritePosition. If you try to write past the end of the allocated space, NI-HSDIO returns an error.
        '''''
        '''''Waveforms are stored contiguously in onboard memory. You cannot resize an existing named waveform. Instead, delete the existing waveform using niHSDIO_DeleteNamedWaveform and then recreate it with the new size using the same name.
        '''''
        '''''This function calls niHSDIO_CommitDynamic--all pending attributes are committed to hardware.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Waveform_Name">
        '''''Specifies a string representing the name to associate with the allocated waveform memory.
        '''''</param>
        '''''<param name="Samples_To_Write">
        '''''Specifies the number of samples in data to be written to onboard memory. This number is not equal to the length of the data[] array, since its size is the number of samples to write times the number of channels.
        '''''
        '''''</param>
        '''''<param name="Data_Layout">
        '''''Describes the layout of the waveform contained in data[].
        '''''
        '''''Defined Values
        '''''
        '''''NIHSDIO_VAL_GROUP_BY_SAMPLE--specifies that consecutive samples in data[] are such that the array contains the first sample from every signal in the operation, then the second sample from every signal, up to the last sample from every signal.
        '''''
        '''''NIHSDIO_VAL_GROUP_BY_CHANNEL--specifies that consecutive samples in data[] are such that the array contains all the samples from the first signal in the operation, then all the samples from the second signal, up to all samples from the last signal. . 
        '''''</param>
        '''''<param name="Data">
        '''''Specifies the digital waveform data. Each value on this array defines the state of one channel of one sample. Supported states are defined in niHSDIO.h.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function WriteNamedWaveformWDT(ByVal Waveform_Name As String, ByVal Samples_To_Write As Integer, ByVal Data_Layout As Integer, ByVal Data() As Byte) As Integer
            Dim pInvokeResult As Integer = PInvoke.WriteNamedWaveformWDT(Me._handle, Waveform_Name, Samples_To_Write, Data_Layout, Data)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Reads and transfers data from a digital .hws file to onboard memory.
        '''''
        '''''If you specify a Waveform_Name not already allocated on the device, the appropriate amount of onboard memory is allocated (if available), and the data is stored in that new location.
        '''''
        '''''Data is always written to memory starting at the current write position of the waveform. A new waveform's write position is the start of the allocated memory. Calling this function moves the next write position to the end of the data just written. Thus, subsequent calls to this function append data to the end of previously written data. You can manually change the write position by calling niHSDIO_SetNamedWaveformNextWritePosition. If you try to write past the end of the allocated space, NI-HSDIO returns an error.
        '''''
        '''''Waveforms are stored contiguously in onboard memory. You cannot resize an existing named waveform. Instead, delete the existing waveform using niHSDIO_DeleteNamedWaveform and then recreate it with the new size using the same name.
        '''''
        '''''This function calls niHSDIO_CommitDynamic--all pending attributes are committed to hardware.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Waveform_Name">
        '''''Specifies a string representing the name to associate with the allocated waveform memory.
        '''''</param>
        '''''<param name="File_Path">
        '''''Specifies the path and file name of the digital .hws file to open. The .hws extension is typically used for .hws files, although using this extension is optional. 
        '''''</param>
        '''''<param name="Use_Rate_From_Waveform">
        '''''Controls how the sample rate is computed.
        '''''
        '''''Setting this value to TRUE computes the generation rate from the WDT value. If the sample rate has been configured using niHSDIO_ConfigureSampleClock function, useRateFromWaveform overrides the sample rate.
        '''''</param>
        '''''<param name="Waveform_Size">
        '''''Returns the number of samples contained in the waveform.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function WriteNamedWaveformFromFileHWS(ByVal Waveform_Name As String, ByVal File_Path As String, ByVal Use_Rate_From_Waveform As Boolean, ByRef Waveform_Size As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.WriteNamedWaveformFromFileHWS(Me._handle, Waveform_Name, File_Path, System.Convert.ToUInt16(Use_Rate_From_Waveform), Waveform_Size)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Sets the idle state for a dynamic generation operation. The idle state may be active in a variety of conditions:
        '''''
        '''''-  The generation operation completes normally.
        '''''-  The generation operation pauses from an active Pause trigger.
        '''''-  The generation operation terminates due to an underflow error.
        '''''
        '''''Valid Syntax:
        '''''
        '''''The order of channelList determines the order of the pattern string. For example, the following two examples are equivalent:
        '''''
        '''''niHSDIO_ConfigureIdleState(vi, "19-0", "0000 0XXX XX11 111Z ZZZZ");
        '''''
        '''''niHSDIO_ConfigureIdleState(vi, "0-19", "ZZZZ Z111 11XX XXX0 0000");
        '''''
        '''''Refer to Initial and Idle States in the NI Digital Waveform Generator/Analyzer Help for more information.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Channel_List">
        '''''Specifies which channels will have their idle value set using the Idle_State string. The order of channels in Channel_List determines the order of Idle_State. 
        '''''</param>
        '''''<param name="Idle_State">
        '''''Describes the idle state of a dynamic generation operation. This expression is composed of characters:
        '''''
        '''''- 'X' or 'x': keeps the previous value
        '''''- '1': sets the channel to logic high
        '''''- '0': sets the channel to logic low
        '''''- 'Z' or 'z': disables the channel (sets it to high-impedance)
        '''''
        '''''The leftmost character in the expression corresponds to the first channel in Channel_List. The number of characters in pattern must equal the number of channels specified in Channel_List or an error is returned.
        '''''
        '''''The default state of a channel is to keep the previous value.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureIdleState(ByVal Channel_List As String, ByVal Idle_State As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureIdleState(Me._handle, Channel_List, Idle_State)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Sets the idle state for a dynamic generation operation. The idle state may be active in a variety of conditions:
        '''''
        '''''-   The generation operation completes normally
        '''''-   The generation operation pauses from an active Pause trigger
        '''''-   The generation operation terminates due to an underflow error
        '''''
        '''''Unlike niHSDIO_ConfigureIdleState, which uses a string, this function uses a binary format to represent only logic high and low. If you require more choices for your idle state, use the niHSDIO_ConfigureIdleState function.
        '''''
        '''''Refer to the Initial and Idle States topic in the NI Digital Waveform Generator/Analyzer Help for more information.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Idle_State">
        '''''Bit mask representing the idle state. High is specified with a 1, and low is specified with a 0.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureIdleStateU32(ByVal Idle_State As UInteger) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureIdleStateU32(Me._handle, Idle_State)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Sets the initial state for a dynamic generation operation. The initial state of each channel is driven after the session is initiated using niHSDIO_Initiate. Channels remain unchanged until the first waveform sample is generated.
        '''''
        '''''The order of Channel_List determines the order of the pattern string. For example, the following two examples are equivalent:
        '''''
        '''''- niHSDIO_ConfigureInitialState (vi, "19-0", "0000 0XXX XX11 111Z ZZZZ");
        '''''
        '''''- niHSDIO_ConfigureInitialState (vi, "0-19", "ZZZZ Z111 11XX XXX0 0000");
        '''''
        '''''Refer to the Initial and Idle States topic in the NI Digital Waveform Generator/Analyzer Help for more information.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Channel_List">
        '''''Specifies which channels will have their initial value set using the Initial_State string. The order of channels in the list determines the order of the Initial_State string.
        '''''</param>
        '''''<param name="Initial_State">
        '''''This string expression describes the initial state of a dynamic generation operation. This expression is composed of characters:
        '''''
        '''''- 'X' or 'x': keeps the previous value
        '''''- '1': sets the channel to logic high
        '''''- '0': sets the channel to logic low
        '''''- 'Z' or 'z': disables the channel or sets it to high-impedance
        '''''
        '''''The leftmost character in the expression corresponds to the first channel in channelList. The number of characters in pattern must equal the number of channels specified in channelList or an error is returned.
        '''''
        '''''The default state of a channel is to keep the previous value.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureInitialState(ByVal Channel_List As String, ByVal Initial_State As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureInitialState(Me._handle, Channel_List, Initial_State)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Sets the initial state for a dynamic generation operation. The initial state of each channel is driven after the session is initiated using niHSDIO_Initiate. Channels remain unchanged until the first waveform sample is generated.
        '''''
        '''''Unlike niHSDIO_ConfigureInitialState which uses a string, this function uses a binary format to represent only logic high and low. If you require more choices for your initial state, use the niHSDIO_ConfigureInitialState function.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Initial_State">
        '''''Bit mask representing the initial state. High is specified with a 1, and low is specified with a 0.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureInitialStateU32(ByVal Initial_State As UInteger) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureInitialStateU32(Me._handle, Initial_State)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Specifies the number of times to generate a waveform or whether to generate it continuously. This function is only valid when the Generation_Mode parameter of niHSDIO_ConfigureGenerationMode is set to NIHSDIO_VAL_WAVEFORM.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Repeat_Mode">
        '''''Specifies the repeat mode to configure:
        '''''
        '''''Defined Values:
        '''''
        '''''- NIHSDIO_VAL_FINITE - Calling niHSDIO_Initiate generates the named waveform a finite number of times. The number of times is specified by the Repeat_Count parameter.
        '''''
        '''''- NIHSDIO_VAL_CONTINUOUS - Calling niHSDIO_Initiate generates the named waveform continuously (until niHSDIO_Abort function is called). Repeat_Count is ignored.
        '''''
        '''''</param>
        '''''<param name="Repeat_Count">
        '''''Specifies the number of times to generate the waveform. This parameter is ignored if Repeat_Mode is NIHSDIO_VAL_CONTINUOUS.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureGenerationRepeat(ByVal Repeat_Mode As Integer, ByVal Repeat_Count As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureGenerationRepeat(Me._handle, Repeat_Mode, Repeat_Count)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Sets the waveform to be generated upon a call to niHSDIO_Initiate when NIHSDIO_ATTR_GENERATION_MODE equals NIHSDIO_VAL_WAVEFORM. This function need only be called if multiple waveforms are present in onboard memory (refer to NIHSDIO_ATTR_WAVEFORM_TO_GENERATE for more information).
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Waveform_Name">
        '''''Specifies which waveform to generate upon calling niHSDIO_Initiate.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureWaveformToGenerate(ByVal Waveform_Name As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureWaveformToGenerate(Me._handle, Waveform_Name)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Reserves waveform space in onboard memory and associates a waveform name with it. Individual waveforms are stored contiguously in onboard memory.
        '''''
        '''''NOTES:
        '''''- niHSDIO_AllocateNamedWaveform sets aside onboard memory space and associates a string name with that space. The name given to the waveform is the same name used in the write named waveform functions, as well as the name used in scripts.
        '''''
        '''''- If not enough space is available to accommodate a waveform of size sizeInSamples, an error is returned and no memory space is created.
        '''''
        '''''- This function does not change any data on the device itself, but rather adds the named reference in software only. Use the write named waveform functions to fill the onboard memory with waveform data to be generated.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Waveform_Name">
        '''''Specifies a string representing the name to associate with the allocated waveform memory.
        '''''</param>
        '''''<param name="Size_In_Samples">
        '''''Specifies the number of samples to allocate for the named waveform.
        '''''
        '''''The number of bits in the allocated samples differs depending on the device you are using. Refer to your device documentation for more information.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function AllocateNamedWaveform(ByVal Waveform_Name As String, ByVal Size_In_Samples As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.AllocateNamedWaveform(Me._handle, Waveform_Name, Size_In_Samples)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Modifies where within a named waveform to next write data. Write Named Waveform functions always begins writing at the current write position.  Existing data in the waveform is overwritten.
        '''''
        '''''The "position" and "offset" parameters are used together to determine where the next write position will be. The "position" parameter describes an absolute (NIHSDIO_VAL_START_OF_WAVEFORM) or relative (NIHSDIO_VAL_CURRENT_READ_POSITION) move.  The "offset" is the number of samples to shift the next write position. You must always set the write position at a position that is a multiple of 32 samples for the NI 654x/655x devices or a multiple of 64 samples for the NI 656x devices (128 samples if the NI 656x is in DDR mode).
        '''''
        '''''Examples of combinations of "position" and "offset"
        '''''-Position: NIHSDIO_VAL_START_OF_WAVEFORM
        '''''-Offset: 0
        '''''-Effect: Write location becomes the start of waveform
        '''''
        '''''-Position: NIHSDIO_VAL_START_OF_WAVEFORM
        '''''-Offset: 5
        '''''-Effect: Write location becomes the sixth sample in waveform
        '''''
        '''''-Position: NIHSDIO_VAL_START_OF_WAVEFORM
        '''''-Offset: -1
        '''''-Effect: ERROR-- The device would try to place the write position before start of waveform.
        '''''
        '''''-Position: NIHSDIO_VAL_CURRENT_READ_POSITION
        '''''-Offset: 0
        '''''-Effect: No effect - leaves next write position unchanged
        '''''
        '''''-Position: NIHSDIO_VAL_CURRENT_POSITION
        '''''-Offset: 10
        '''''-Effect: Shift write position 10 samples ahead from current write location. This position setting is only valid if the current write position plus this offset is in the waveform. 
        '''''
        '''''-Position: NIHSDIO_VAL_CURRENT_POSITION
        '''''-Offset: -10
        '''''-Effect: Shift write position 10 samples back from current location. This position setting is only valid if the current write position is greater than 10.
        '''''
        '''''The write position is moved to the end of the most recently written data after each call to a Write Named Waveform function.  Thus you do not need to explicitly call niHSDIO_SetNamedWaveformNextWritePosition.
        '''''
        '''''Attempting to set the write position past the end of the allocated space results in an error.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Waveform_Name">
        '''''Specifies a string representing the name to associate with the allocated waveform memory.
        '''''</param>
        '''''<param name="Position">
        '''''Specifies where to place the write position (in conjunction with offset):
        '''''
        '''''Defined Values:
        '''''
        '''''-   NIHSDIO_VAL_START_OF_WAVEFORM - Offset is relative to the beginning of the waveform.
        '''''-   NIHSDIO_VAL_CURRENT_POSITION - Offset is relative to the current write position in the waveform.
        '''''
        '''''</param>
        '''''<param name="Offset">
        '''''Specifies the write position of the name waveform in conjunction with the mode attribute. Offset is in samples.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function SetNamedWaveformNextWritePosition(ByVal Waveform_Name As String, ByVal Position As Integer, ByVal Offset As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.SetNamedWaveformNextWritePosition(Me._handle, Waveform_Name, Position, Offset)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Frees a named waveform space in onboard memory.
        '''''
        '''''NOTE: This function releases onboard memory space previously allocated by either the niHSDIO_AllocateNamedWaveform or niHSDIO_WriteNamedWaveform functions. Any future reference to the deleted waveform results in an error. However, previously written scripts that still reference the deleted waveform do not generate an error at initiation.
        '''''
        '''''An error is generated if the waveform name is not allocated in onboard memory.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Waveform_Name">
        '''''Specifies the name of the waveform to delete.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function DeleteNamedWaveform(ByVal Waveform_Name As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.DeleteNamedWaveform(Me._handle, Waveform_Name)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures whether to generate the waveform specified in NIHSDIO_ATTR_WAVEFORM_TO_GENERATE or the script specified in NIHSDIO_ATTR_SCRIPT_TO_GENERATE upon calling niHSDIO_Initiate.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Generation_Mode">
        '''''Specifies the generation mode to configure.
        '''''
        '''''Defined Values:
        '''''
        '''''- NIHSDIO_VAL_WAVEFORM - Calling niHSDIO_Initiate generates the named waveform represented by NIHSDIO_ATTR_WAVEFORM_TO_GENERATE.
        '''''- NIHSDIO_VAL_SCRIPTED - Calling niHSDIO_Initiate generates the script represented by NIHSDIO_ATTR_SCRIPT_TO_GENERATE.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureGenerationMode(ByVal Generation_Mode As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureGenerationMode(Me._handle, Generation_Mode)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Writes a string containing scripts that governs the generation of waveforms. If this function is called repeatedly, previously written scripts with unique names remain loaded. Previously written scripts with identical names to those being written are replaced.
        '''''
        '''''If multiple scripts are loaded when niHSDIO_Initiate is called, then one of the scripts must be designated as the script to generate by setting NIHSDIO_ATTR_SCRIPT_TO_GENERATE to the desired script name. If only one script is in memory, then there is no need to designate the script to generate. All waveforms referenced in the scripts must be written before the script is written.
        '''''
        '''''An error is returned if the script uses incorrect syntax. This function calls niHSDIO_CommitDynamic. All pending attributes are committed to hardware.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Script">
        '''''Specifies a string containing a syntactically correct script.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function WriteScript(ByVal Script As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.WriteScript(Me._handle, Script)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Sets the script to be generated upon a call to the niHSDIO_Initiate function when NIHSDIO_ATTR_GENERATION_MODE is set to NIHSDIO_VAL_SCRIPTED. If there are multiple scripts loaded when niHSDIO_Initiate is called, one script must be designated as the script to generate or NI-HSDIO returns an error. You only need to call this function if multiple scripts are present in onboard memory (refer to NIHSDIO_ATTR_SCRIPT_TO_GENERATE for more information).
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Script_Name">
        '''''Specifies which script to generate after calling niHSDIO_Initiate.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureScriptToGenerate(ByVal Script_Name As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureScriptToGenerate(Me._handle, Script_Name)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the Sample clock. This function allows you to specify the clock source and rate for the Sample clock.
        '''''
        '''''If Clock_Source is set to NIHSDIO_VAL_ON_BOARD_CLOCK_STR, NI-HSDIO coerces the rate to a value that is supported by the hardware. Use niHSDIO_GetAttributeViReal64 to get the value for NIHSDIO_ATTR_SAMPLE_CLOCK_RATE to see to what value NI-HSDIO has coerced the Sample clock rate.
        '''''
        '''''Clock_Source can be set to NIHSDIO_VAL_STROBE_STR for acquisition only.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Clock_Source">
        '''''Specifies the Sample clock source. Refer to NIHSDIO_ATTR_SAMPLE_CLOCK_SOURCE for details.
        '''''
        '''''Defined Values:
        '''''
        '''''-NIHSDIO_VAL_ON_BOARD_CLOCK_STR - The device uses the On Board Clock as the Sample clock source.
        '''''-NIHSDIO_VAL_STROBE_STR - The device uses the signal present on the STROBE channel as the Sample clock source. This choice is only valid for acquisition operations.
        '''''-NIHSDIO_VAL_CLK_IN_STR - The device uses the signal present on the front panel CLK IN SMB jack connector as the Sample clock source.
        '''''-NIHSDIO_VAL_PXI_STAR_STR - The device uses the signal present on the PXI_STAR line as the Sample clock source. This choice is valid for devices in slots that support PXI_STAR.
        '''''</param>
        '''''<param name="Clock_Rate">
        '''''Specifies the Sample clock rate, expressed in Hz. You must set this property even when you supply an external clock because NI-HSDIO uses this property for a number of reasons, including optimal error checking and certain pulse width selections.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureSampleClock(ByVal Clock_Source As String, ByVal Clock_Rate As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureSampleClock(Me._handle, Clock_Source, Clock_Rate)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Sets up channels to be clocked in various ways by the sample clock edges. You have three options for data position: rising edge, falling edge, or delayed.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Channel_List">
        '''''Identifies channels to apply settings. Use "" or VI_NULL to specify all channels.
        '''''</param>
        '''''<param name="Position">
        '''''Specifies which edge of the Sample clock signal is used to time the operation. You can also configure the device to generate data at a configurable delay past each rising edge of the Sample clock.
        '''''
        '''''Defined Values
        '''''
        '''''NIHSDIO_VAL_SAMPLE_CLOCK_RISING_EDGE - The device samples or generates data on the rising edge of the Sample clock.
        '''''NIHSDIO_VAL_SAMPLE_CLOCK_FALLING_EDGE - The device samples or generates data on the falling edge of the Sample clock.
        '''''NIHSDIO_VAL_DELAY_FROM_SAMPLE_CLOCK_RISING_EDGE - The device samples or generates data with delay from rising edge of the Sample clock. Specify the delay using NIHSDIO_ATTR_DATA_POSITION_DELAY.
        '''''
        '''''NOTES:
        '''''
        '''''NIHSDIO_VAL_DELAY_FROM_SAMPLE_CLOCK_RISING_EDGE has more jitter than the rising or falling edge values.
        '''''
        '''''Certain devices have sample clock frequency limitations when a custom delay is used. Refer to the device documentation for details.
        '''''
        '''''To configure a delay on NI 656x devices,you must delay all channels on the device. NI-HSDIO returns an error if you apply a delay to only a partial channel list.
        '''''
        '''''Default Value: NIHSDIO_VAL_SAMPLE_CLOCK_RISING_EDGE 
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureDataPosition(ByVal Channel_List As String, ByVal Position As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureDataPosition(Me._handle, Channel_List, Position)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Sets up the data delay with respect to the Sample clock.
        '''''
        '''''NOTE:  To configure a delay on NI 656x devices, you must delay all channels on the device. NI-HSDIO returns an error if you apply a delay to only a partial channel list.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Channel_List">
        '''''Identifies channels to apply settings. Use "" or VI_NULL to specify all channels.
        '''''</param>
        '''''<param name="Delay">
        '''''Specifies the delay after the Sample clock rising edge when the device generates or acquires a new data sample. Data delay is expressed as a fraction of the clock period, that is, a fraction of 1/NIHSDIO_ATTR_SAMPLE_CLOCK_RATE. All the channels in the session that use delayed Sample clock to position data must have the same delay value.
        '''''
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureDataPositionDelay(ByVal Channel_List As String, ByVal Delay As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureDataPositionDelay(Me._handle, Channel_List, Delay)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the Reference clock. Use this function when you are using the On Board Clock as a Sample clock, and you want the Sample clock to be phase-locked to a Reference signal. Phase-locking the Sample clock to a Reference clock prevents the Sample clock from "drifting" relative to the Reference clock.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Clock_Source">
        '''''Specifies the PLL reference clock source. Refer to NIHSDIO_ATTR_REF_CLOCK_SOURCE for details.
        '''''
        '''''Defined Values:
        '''''
        '''''-NIHSDIO_VAL_NONE_STR - The device will not use a Reference clock.
        '''''-NIHSDIO_VAL_CLK_IN_STR - The device uses the signal present on the front panel CLK IN SMB jack connector as the Reference clock source.
        '''''-NIHSDIO_VAL_PXI_CLK10_STR - The device uses the 10 MHz PXI backplane clock as the Reference clock source. This source is only available for PXI devices.
        '''''-NIHSDIO_VAL_RTSI7_STR - The device uses the signal on RTSI 7 as the Reference clock source. This source is only available for PCI devices.
        '''''</param>
        '''''<param name="Clock_Rate">
        '''''Specifies the Reference clock rate, expressed in Hz.
        '''''
        '''''Defined Values:
        '''''
        '''''Refer to NIHSDIO_ATTR_REF_CLOCK_RATE for details.
        '''''
        '''''Default Value: 10000000
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureRefClock(ByVal Clock_Source As String, ByVal Clock_Rate As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureRefClock(Me._handle, Clock_Source, Clock_Rate)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Delays the Sample clock relative to the Reference clock. Use this function to align the Sample clock of your device to the Sample clock of another device in your system. 
        '''''
        '''''Only call this function after your session is committed. The effect of this function is immediate.
        '''''
        '''''This function generates an error if NIHSDIO_ATTR_REF_CLOCK_SOURCE is set to NIHSDIO_VAL_NONE_STR.
        '''''
        '''''This function can only align the device Sample clock to another Sample clock if the other device is using the same reference clock source.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from the function used to initialize the session.
        '''''
        '''''</param>
        '''''<param name="Adjustment_Time">
        '''''Specifies the time in seconds to delay the Sample clock. Values range between 0 and the Sample clock period (1/NIHSDIO_ATTR_SAMPLE_CLOCK_RATE).
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function AdjustSampleClockRelativeDelay(ByVal Adjustment_Time As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.AdjustSampleClockRelativeDelay(Me._handle, Adjustment_Time)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the Start trigger for edge triggering.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Source">
        '''''You may specify any valid source terminal for this trigger. Trigger voltages and positions are only relevant if the source of the trigger is from the front panel connectors.
        '''''
        '''''Defined Values:
        '''''
        '''''Refer to NIHSDIO_ATTR_DIGITAL_EDGE_START_TRIGGER_SOURCE for possible values.
        '''''</param>
        '''''<param name="Edge">
        '''''Specifies the edge to detect:
        '''''
        '''''Defined Values:
        '''''
        '''''- NIHSDIO_VAL_RISING_EDGE - rising edge trigger
        '''''- NIHSDIO_VAL_FALLING_EDGE - falling edge trigger
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureDigitalEdgeStartTrigger(ByVal Source As String, ByVal Edge As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureDigitalEdgeStartTrigger(Me._handle, Source, Edge)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the start trigger for pattern match triggering. This function is only valid for acquisition operations.
        '''''
        '''''Valid Syntax:
        '''''
        '''''Both of these examples are valid and do the same thing. The order of channelList determines the order of the pattern string.
        '''''
        '''''- niHSDIO_ConfigurePatternMatchStartTrigger (vi, "19-0", "0000 0XXX XX11 1111 1111");
        '''''
        '''''- niHSDIO_ConfigurePatternMatchStartTrigger (vi, "0-19", "1111 1111 11XX XXX0 0000");
        '''''
        '''''NOTE: The logic levels seen by pattern matching are affected by data interpretation.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Channel_List">
        '''''This string specifies which channels will be configured for pattern matching using the pattern string. The order of channels in the list determines the order of the pattern string.
        '''''</param>
        '''''<param name="Pattern">
        '''''This string expression describes the pattern to be matched. This expression is composed of characters:
        '''''
        '''''- 'X' or 'x': ignore the channel
        '''''- '1' : match on a logic 1
        '''''- '0': match on a logic 0
        '''''- 'R' or 'r': match on a rising edge
        '''''- 'F' or 'f': match on a falling edge
        '''''- 'E' or 'e': match on either edge
        '''''
        '''''The first character in the expression corresponds to the first channel in Channel_List. The number of characters in pattern must correspond to the number of channels specified in Channel_List.
        '''''
        '''''
        '''''</param>
        '''''<param name="Trigger_When">
        '''''Specifies the when the trigger asserts:
        '''''
        '''''Defined Values:
        '''''
        '''''- NIHSDIO_VAL_PATTERN_MATCHES - the trigger activates when the pattern matches
        '''''
        '''''- NIHSDIO_VAL_PATTERN_DOES_NOT_MATCH - the trigger activates when the pattern does not match
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigurePatternMatchStartTrigger(ByVal Channel_List As String, ByVal Pattern As String, ByVal Trigger_When As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigurePatternMatchStartTrigger(Me._handle, Channel_List, Pattern, Trigger_When)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the Start trigger for pattern match triggering.
        '''''
        '''''Unlike niHSDIO_ConfigurePatternMatchStartTrigger which uses a string, this function uses a binary format to only represent high and low. If you require more choices for your pattern, use the niHSDIO_ConfigurePatternMatchStartTrigger function.
        '''''
        '''''This function is only valid for acquisition operations.
        '''''
        '''''NOTE: The logic levels seen by pattern matching are affected by data interpretation.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Channel_List">
        '''''This string specifies which channels will be configured for pattern matching using the pattern string. The order of channels in the list determines the order of the pattern string.
        '''''
        '''''</param>
        '''''<param name="Pattern">
        '''''Specifies the binary pattern that activates the pattern match trigger under the conditions specified in Trigger_When.
        '''''
        '''''Bits on channels not specified in Channel_List are ignored.
        '''''
        '''''</param>
        '''''<param name="Trigger_When">
        '''''Specifies the when the trigger asserts:
        '''''
        '''''Defined Values:
        '''''
        '''''- NIHSDIO_VAL_PATTERN_MATCHES - the trigger activates when the pattern matches
        '''''
        '''''- NIHSDIO_VAL_PATTERN_DOES_NOT_MATCH - the trigger activates when the pattern does not match
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigurePatternMatchStartTriggerU32(ByVal Channel_List As String, ByVal Pattern As UInteger, ByVal Trigger_When As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigurePatternMatchStartTriggerU32(Me._handle, Channel_List, Pattern, Trigger_When)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the Start trigger for software triggering.
        '''''
        '''''
        '''''Refer to niHSDIO_SendSoftwareEdgeTrigger for more information on using the software Start trigger.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureSoftwareStartTrigger() As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureSoftwareStartTrigger(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the device to not wait for a Start trigger after the niHSDIO_Initiate function is called. Calling this function is only necessary if you have configured a Start trigger and now want to disable it.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function DisableStartTrigger() As Integer
            Dim pInvokeResult As Integer = PInvoke.DisableStartTrigger(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the Reference trigger for edge triggering in an acquisition. If the Reference trigger asserts before all of the pretrigger samples are acquired, then it is ignored. This function is only valid for acquisition operations.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Source">
        '''''You may specify any valid source terminal for this trigger. Trigger voltages and positions are only relevant if the source of the trigger is from the front panel connectors.
        '''''
        '''''Defined Values:
        '''''
        '''''Refer to NIHSDIO_ATTR_DIGITAL_EDGE_REF_TRIGGER_SOURCE for possible values.
        '''''</param>
        '''''<param name="Edge">
        '''''Specifies the edge to detect.
        '''''
        '''''Defined Values:
        '''''
        '''''- NIHSDIO_VAL_RISING_EDGE - rising edge trigger
        '''''- NIHSDIO_VAL_FALLING_EDGE - falling edge trigger
        '''''
        '''''</param>
        '''''<param name="Pretrigger_Samples">
        '''''Specifies the number of necessary pretrigger samples before the Reference trigger is acknowledged.
        '''''
        '''''Default Value: 500
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureDigitalEdgeRefTrigger(ByVal Source As String, ByVal Edge As Integer, ByVal Pretrigger_Samples As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureDigitalEdgeRefTrigger(Me._handle, Source, Edge, Pretrigger_Samples)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the Reference trigger for pattern match triggering. If the reference trigger asserts before all of the pretrigger samples are acquired, then it is ignored. This function is only valid for acquisition sessions.
        '''''
        '''''Valid Syntax:
        '''''
        '''''Both of these examples are valid and do the same thing. The order of channelList determines the order of the pattern string.
        '''''
        '''''- niHSDIO_ConfigurePatternMatchRefTrigger (vi, "19-0", "0000 0XXX XX11 111Z ZZZZ");
        '''''
        '''''- niHSDIO_ConfigurePatternMatchRefTrigger (vi, "0-19", "ZZZZ Z111 11XX XXX0 0000");
        '''''
        '''''NOTE: The logic levels seen by pattern matching are affected by data interpretation.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Channel_List">
        '''''This string specifies which channels are configured for pattern matching using the pattern string. The order of channels in the list determines the order of the pattern string.
        '''''</param>
        '''''<param name="Pattern">
        '''''This string expression describes the pattern to be matched. This expression is composed of characters:
        '''''
        '''''- 'X' or 'x': ignore the channel
        '''''- '1': match on a logic 1
        '''''- '0': match on a logic 0
        '''''- 'R' or 'r': match on a rising edge
        '''''- 'F' or 'f': match on a falling edge
        '''''- 'E' or 'e': match on either edge
        '''''
        '''''The leftmost character in the expression corresponds to the first channel in channelList. The number of characters in pattern must correspond to the number of channels specified in channelList or an error is returned.
        '''''
        '''''
        '''''</param>
        '''''<param name="Trigger_When">
        '''''Specifies the when the trigger asserts.
        '''''
        '''''Defined Values:
        '''''
        '''''- NIHSDIO_VAL_PATTERN_MATCHES - the trigger activates when the pattern matches
        '''''
        '''''- NIHSDIO_VAL_PATTERN_DOES_NOT_MATCH - the trigger activates when the pattern does not match
        '''''
        '''''</param>
        '''''<param name="Pretrigger_Samples">
        '''''Specifies the number of necessary pretrigger samples before the reference trigger is acknowledged.
        '''''
        '''''Default Value: 500
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigurePatternMatchRefTrigger(ByVal Channel_List As String, ByVal Pattern As String, ByVal Trigger_When As Integer, ByVal Pretrigger_Samples As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigurePatternMatchRefTrigger(Me._handle, Channel_List, Pattern, Trigger_When, Pretrigger_Samples)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the Reference trigger for pattern match triggering. If the reference trigger asserts before all of the pretrigger samples are acquired, then it is ignored.
        '''''
        '''''Unlike niHSDIO_ConfigurePatternMatchRefTrigger which uses a string, this function uses a binary format to only represent high and low. If you require more choices for your pattern, use the niHSDIO_ConfigurePatternMatchRefTrigger function.
        '''''
        '''''This function is only valid for acquisition sessions.
        '''''
        '''''NOTE: The logic levels seen by pattern matching are affected by data interpretation.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Channel_List">
        '''''This string specifies which channels are configured for pattern matching using the pattern string. The order of channels in the list determines the order of the pattern string.
        '''''</param>
        '''''<param name="Pattern">
        '''''Specifies the binary pattern that activates the pattern match trigger under the conditions specified in Trigger_When.
        '''''
        '''''Bits on channels not specified in Channel_List are ignored.
        '''''</param>
        '''''<param name="Trigger_When">
        '''''Specifies the when the trigger asserts.
        '''''
        '''''Defined Values:
        '''''
        '''''- NIHSDIO_VAL_PATTERN_MATCHES - the trigger activates when the pattern matches
        '''''
        '''''- NIHSDIO_VAL_PATTERN_DOES_NOT_MATCH - the trigger activates when the pattern does not match
        '''''
        '''''</param>
        '''''<param name="Pretrigger_Samples">
        '''''Specifies the number of necessary pretrigger samples before the reference trigger is acknowledged.
        '''''
        '''''Default Value: 500
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigurePatternMatchRefTriggerU32(ByVal Channel_List As String, ByVal Pattern As UInteger, ByVal Trigger_When As Integer, ByVal Pretrigger_Samples As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigurePatternMatchRefTriggerU32(Me._handle, Channel_List, Pattern, Trigger_When, Pretrigger_Samples)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the reference trigger for software triggering. If the reference trigger asserts before all of the pretrigger samples are acquired, then it is ignored. This function is valid only for acquisition sessions.
        '''''
        '''''Refer to niHSDIO_SendSoftwareEdgeTrigger for more information on the software reference trigger.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Pretrigger_Samples">
        '''''Specifies the number of necessary pretrigger samples before the reference trigger is acknowledged.
        '''''
        '''''Default Value: 500
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureSoftwareRefTrigger(ByVal Pretrigger_Samples As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureSoftwareRefTrigger(Me._handle, Pretrigger_Samples)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the acquisition operation to have no Reference trigger. Calling this function is only necessary if you have configured a Reference trigger and now want to disable it. This function is valid only for acquisition sessions.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function DisableRefTrigger() As Integer
            Dim pInvokeResult As Integer = PInvoke.DisableRefTrigger(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the Advance trigger for edge triggering in an acquisition.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Source">
        '''''You may specify any valid source terminal for this trigger. Trigger voltages and positions are only relevant if the source of the trigger is from the front panel connectors.
        '''''
        '''''Defined Values:
        '''''
        '''''Refer to NIHSDIO_ATTR_DIGITAL_EDGE_ADVANCE_TRIGGER_SOURCE for possible values.
        '''''</param>
        '''''<param name="Edge">
        '''''Specifies the edge to detect.
        '''''
        '''''Defined Values:
        '''''
        '''''- NIHSDIO_VAL_RISING_EDGE - rising edge trigger
        '''''- NIHSDIO_VAL_FALLING_EDGE - falling edge trigger
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureDigitalEdgeAdvanceTrigger(ByVal Source As String, ByVal Edge As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureDigitalEdgeAdvanceTrigger(Me._handle, Source, Edge)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the Advance trigger for pattern match triggering. This function is only valid for acquisition operations.
        '''''
        '''''Valid Syntax:
        '''''
        '''''Both of these examples are valid and do the same thing. The order of channelList determines the order of the pattern string.
        '''''
        '''''- niHSDIO_ConfigurePatternMatchAdvanceTrigger (vi, "19-0", "0000 0XXX XX11 1111 1111");
        '''''
        '''''- niHSDIO_ConfigurePatternMatchAdvanceTrigger (vi, "0-19", "1111 1111 11XX XXX0 0000");
        '''''
        '''''NOTE: The logic levels seen by pattern matching are affected by data interpretation.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Channel_List">
        '''''This string specifies which channels will be configured for pattern matching using the pattern string. The order of channels in the list determines the order of the pattern string.
        '''''</param>
        '''''<param name="Pattern">
        '''''This string expression describes the pattern to be matched. This expression is composed of characters:
        '''''
        '''''- 'X' or 'x': ignore the channel
        '''''- '1' : match on a logic 1
        '''''- '0': match on a logic 0
        '''''- 'R' or 'r': match on a rising edge
        '''''- 'F' or 'f': match on a falling edge
        '''''- 'E' or 'e': match on either edge
        '''''
        '''''The first character in the expression corresponds to the first channel in Channel_List. The number of characters in pattern must correspond to the number of channels specified in Channel_List.
        '''''
        '''''
        '''''</param>
        '''''<param name="Trigger_When">
        '''''Specifies the when the trigger asserts:
        '''''
        '''''Defined Values:
        '''''
        '''''- NIHSDIO_VAL_PATTERN_MATCHES - the trigger activates when the pattern matches
        '''''
        '''''- NIHSDIO_VAL_PATTERN_DOES_NOT_MATCH - the trigger activates when the pattern does not match
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigurePatternMatchAdvanceTrigger(ByVal Channel_List As String, ByVal Pattern As String, ByVal Trigger_When As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigurePatternMatchAdvanceTrigger(Me._handle, Channel_List, Pattern, Trigger_When)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the Advance trigger for pattern match triggering. This function is only valid for acquisition operations.
        '''''
        '''''Unlike niHSDIO_ConfigurePatternMatchAdvanceTrigger which uses a string, this function uses a binary format to only represent high and low. If you require more choices for your pattern, use the niHSDIO_ConfigurePatternMatchAdvanceTrigger function.
        '''''
        '''''
        '''''NOTE: The logic levels seen by pattern matching are affected by data interpretation.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Channel_List">
        '''''This string specifies which channels will be configured for pattern matching using the pattern string. The order of channels in the list determines the order of the pattern string.
        '''''</param>
        '''''<param name="Pattern">
        '''''Specifies the binary pattern that activates the pattern match trigger under the conditions specified in Trigger_When.
        '''''
        '''''Bits on channels not specified in Channel_List are ignored. 
        '''''
        '''''</param>
        '''''<param name="Trigger_When">
        '''''Specifies the when the trigger asserts:
        '''''
        '''''Defined Values:
        '''''
        '''''- NIHSDIO_VAL_PATTERN_MATCHES - the trigger activates when the pattern matches
        '''''
        '''''- NIHSDIO_VAL_PATTERN_DOES_NOT_MATCH - the trigger activates when the pattern does not match
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigurePatternMatchAdvanceTriggerU32(ByVal Channel_List As String, ByVal Pattern As UInteger, ByVal Trigger_When As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigurePatternMatchAdvanceTriggerU32(Me._handle, Channel_List, Pattern, Trigger_When)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the Advance trigger for software triggering.
        '''''
        '''''
        '''''Refer to niHSDIO_SendSoftwareEdgeTrigger for more information on using the software Advance trigger.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureSoftwareAdvanceTrigger() As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureSoftwareAdvanceTrigger(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the acquisition operation to have no Advance trigger. Calling this function is only necessary if you have configured a Advance trigger and now want to disable it. This function is valid only for acquisition sessions.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function DisableAdvanceTrigger() As Integer
            Dim pInvokeResult As Integer = PInvoke.DisableAdvanceTrigger(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the Script trigger for edge triggering. This function is only valid for generation sessions that use scripting.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Trigger_ID">
        '''''Identifies which Script trigger this function configures.
        '''''
        '''''Defined Values:
        '''''
        '''''NIHSDIO_VAL_SCRIPT_TRIGGER0
        '''''NIHSDIO_VAL_SCRIPT_TRIGGER1
        '''''NIHSDIO_VAL_SCRIPT_TRIGGER2
        '''''NIHSDIO_VAL_SCRIPT_TRIGGER3
        '''''</param>
        '''''<param name="Source">
        '''''You may specify any valid source terminal for this trigger. Trigger voltages and positions are only relevant if the source of the trigger is from the front panel connectors.
        '''''
        '''''Defined Values:
        '''''
        '''''Refer to NIHSDIO_ATTR_DIGITAL_EDGE_SCRIPT_TRIGGER_SOURCE for possible values.
        '''''</param>
        '''''<param name="Edge">
        '''''Specifies the edge to detect.
        '''''
        '''''Defined Values:
        '''''
        '''''- NIHSDIO_VAL_RISING_EDGE - rising edge trigger
        '''''- NIHSDIO_VAL_FALLING_EDGE - falling edge trigger
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureDigitalEdgeScriptTrigger(ByVal Trigger_ID As String, ByVal Source As String, ByVal Edge As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureDigitalEdgeScriptTrigger(Me._handle, Trigger_ID, Source, Edge)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the Script trigger for level triggering. This function is only valid for generation sessions that use scripting.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Trigger_ID">
        '''''Identifies which script trigger this function configures.
        '''''
        '''''Defined Values:
        '''''
        '''''NIHSDIO_VAL_SCRIPT_TRIGGER0
        '''''NIHSDIO_VAL_SCRIPT_TRIGGER1
        '''''NIHSDIO_VAL_SCRIPT_TRIGGER2
        '''''NIHSDIO_VAL_SCRIPT_TRIGGER3
        '''''</param>
        '''''<param name="Source">
        '''''You may specify any valid source terminal for this trigger. Trigger voltages and positions are only relevant if the source of the trigger is from the front panel connectors.
        '''''
        '''''Defined Values:
        '''''
        '''''Refer to NIHSDIO_ATTR_DIGITAL_LEVEL_SCRIPT_TRIGGER_SOURCE for possible values.
        '''''</param>
        '''''<param name="Trigger_When">
        '''''Specifies the active level for the desired trigger.
        '''''
        '''''Defined Values:
        '''''
        '''''- NIHSDIO_VAL_HIGH - trigger is active while its source is high
        '''''
        '''''- NIHSDIO_VAL_LOW - trigger is active while its source is low
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureDigitalLevelScriptTrigger(ByVal Trigger_ID As String, ByVal Source As String, ByVal Trigger_When As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureDigitalLevelScriptTrigger(Me._handle, Trigger_ID, Source, Trigger_When)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the Script trigger for software triggering. This function is only valid for generation sessions that use scripting.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Trigger_ID">
        '''''Identifies which script trigger this function configures.
        '''''
        '''''Defined Values:
        '''''
        '''''NIHSDIO_VAL_SCRIPT_TRIGGER0
        '''''NIHSDIO_VAL_SCRIPT_TRIGGER1
        '''''NIHSDIO_VAL_SCRIPT_TRIGGER2
        '''''NIHSDIO_VAL_SCRIPT_TRIGGER3
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureSoftwareScriptTrigger(ByVal Trigger_ID As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureSoftwareScriptTrigger(Me._handle, Trigger_ID)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Sets the data operation to not have a Script trigger. Calling this function is only necessary if you  have configured a particular Script trigger and now want to disable it. This function is only valid for generation sessions.
        '''''
        '''''
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Trigger_ID">
        '''''Identifies which Script trigger this function will configure.
        '''''
        '''''Defined Values:
        '''''
        '''''NIHSDIO_VAL_SCRIPT_TRIGGER0
        '''''NIHSDIO_VAL_SCRIPT_TRIGGER1
        '''''NIHSDIO_VAL_SCRIPT_TRIGGER2
        '''''NIHSDIO_VAL_SCRIPT_TRIGGER3
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function DisableScriptTrigger(ByVal Trigger_ID As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.DisableScriptTrigger(Me._handle, Trigger_ID)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the pause trigger for level triggering.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Source">
        '''''You may specify any valid source terminal for this trigger. Trigger voltages and positions are only relevant if the source of the trigger is from the front panel connectors.
        '''''
        '''''Defined Values:
        '''''
        '''''Refer to NIHSDIO_ATTR_DIGITAL_LEVEL_PAUSE_TRIGGER_SOURCE for possible values.
        '''''</param>
        '''''<param name="Trigger_When">
        '''''Specifies the active level for the desired trigger.
        '''''
        '''''Defined Values:
        '''''
        '''''- NIHSDIO_VAL_HIGH - trigger is active while its source is high
        '''''- NIHSDIO_VAL_LOW - trigger is active while its source is low
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigureDigitalLevelPauseTrigger(ByVal Source As String, ByVal Trigger_When As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureDigitalLevelPauseTrigger(Me._handle, Source, Trigger_When)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the pause trigger for pattern match triggering. This function is valid only for acquisition sessions.
        '''''
        '''''Valid Syntax:
        '''''
        '''''Both of these examples are valid and do the same thing. The order of channelList determines the order of the pattern string.
        '''''
        '''''- niHSDIO_ConfigurePatternMatchPauseTrigger (vi, "19-0", "0000 0XXX XX11 1111 1111");
        '''''
        '''''- niHSDIO_ConfigurePatternMatchPauseTrigger (vi, "0-19", "1111 1111 11XX XXX0 0000");
        '''''
        '''''NOTE: The values seen by pattern matching is affected by data interpretation.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Channel_List">
        '''''This string specifies which channels are configured for pattern matching using the pattern string. The order of channels in the list determines the order of the pattern string. Ex. "0-19" and "19-0" are reverse of one another.
        '''''</param>
        '''''<param name="Pattern">
        '''''This string expression describes the pattern to be matched. This expression is composed of characters:
        '''''
        '''''- 'X' or 'x': ignore the channel
        '''''- '1': match on a logic 1
        '''''- '0': match on a logic 0
        '''''- 'R' or 'r': match on a rising edge
        '''''- 'F' or 'f': match on a falling edge
        '''''- 'E' or 'e': match on either edge
        '''''
        '''''The leftmost character in the expression corresponds to the first channel in channelList. The number of characters in pattern must correspond to the number of channels specified in channelList or an error is returned.
        '''''
        '''''</param>
        '''''<param name="Trigger_When">
        '''''Specifies the when the trigger asserts.
        '''''
        '''''Defined Values:
        '''''
        '''''- NIHSDIO_VAL_PATTERN_MATCHES - the trigger activates when the pattern matches
        '''''
        '''''- NIHSDIO_VAL_PATTERN_DOES_NOT_MATCH - the trigger activates when the pattern does not match
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigurePatternMatchPauseTrigger(ByVal Channel_List As String, ByVal Pattern As String, ByVal Trigger_When As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigurePatternMatchPauseTrigger(Me._handle, Channel_List, Pattern, Trigger_When)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the pause trigger for pattern match triggering. This function is valid only for acquisition sessions.
        '''''
        '''''Unlike niHSDIO_ConfigurePatternMatchPauseTrigger which uses a string, this function uses a binary format to only represent high and low. If you require more choices for your pattern, use the niHSDIO_ConfigurePatternMatchPauseTrigger function.
        '''''
        '''''NOTE: The values seen by pattern matching is affected by data interpretation.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Channel_List">
        '''''This string specifies which channels are configured for pattern matching using the pattern string. The order of channels in the list determines the order of the pattern string. Ex. "0-19" and "19-0" are reverse of one another.
        '''''</param>
        '''''<param name="Pattern">
        '''''Specifies the binary pattern that activates the pattern match trigger under the conditions specified in Trigger_When.
        '''''
        '''''Bits on channels not specified in Channel_List are ignored.
        '''''</param>
        '''''<param name="Trigger_When">
        '''''Specifies the when the trigger asserts.
        '''''
        '''''Defined Values:
        '''''
        '''''- NIHSDIO_VAL_PATTERN_MATCHES - the trigger activates when the pattern matches
        '''''
        '''''- NIHSDIO_VAL_PATTERN_DOES_NOT_MATCH - the trigger activates when the pattern does not match
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ConfigurePatternMatchPauseTriggerU32(ByVal Channel_List As String, ByVal Pattern As UInteger, ByVal Trigger_When As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigurePatternMatchPauseTriggerU32(Me._handle, Channel_List, Pattern, Trigger_When)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Sets the data operation to have no Pause trigger. Calling this function is only necessary if you have configured a Pause trigger and now want to disable it.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function DisablePauseTrigger() As Integer
            Dim pInvokeResult As Integer = PInvoke.DisablePauseTrigger(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Use this function to force a particular edge-based trigger to occur. This function applies to the Start, Reference, Advance, and Script triggers, and is valid if the particular trigger is configured for edge, pattern match, or software triggering (for edge or pattern match triggers you can use niHSDIO_SendSoftwareEdgeTrigger as a software override).
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Trigger">
        '''''The trigger to assert. 
        '''''
        '''''Defined Values:
        '''''
        '''''- NIHSDIO_VAL_START_TRIGGER - Start trigger for dynamic acquisition or generation
        '''''
        '''''- NIHSDIO_VAL_REF_TRIGGER - Reference trigger for dynamic acqusition
        '''''
        '''''- NIHSDIO_VAL_SCRIPT_TRIGGER - Script trigger for dynamic generation
        '''''
        '''''
        '''''</param>
        '''''<param name="Trigger_Identifier">
        '''''Describes the software trigger. For example, NIHSDIO_VAL_SCRIPT_TRIGGER0 could be the identifier for the Script trigger, or you could have an empty string for the Start and Reference triggers. 
        '''''
        ''''' - NIHSDIO_VAL_SCRIPT_TRIGGER0
        ''''' - NIHSDIO_VAL_SCRIPT_TRIGGER1
        ''''' - NIHSDIO_VAL_SCRIPT_TRIGGER2
        ''''' - NIHSDIO_VAL_SCRIPT_TRIGGER3
        ''''' - "" (empty string) or VI_NULL
        '''''
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function SendSoftwareEdgeTrigger(ByVal Trigger As Integer, ByVal Trigger_Identifier As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.SendSoftwareEdgeTrigger(Me._handle, Trigger, Trigger_Identifier)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Use this function to route signals (clocks, triggers, and events) to the output terminal you specify. Refer to your device documentation for valid signal destinations.
        '''''
        '''''Any routes created within a session persist after the session closes to prevent signal glitching. To unconfigure signal routes created in previous sessions, set the Reset_Instrument parameter in niHSDIO_InitGenerationSession or niHSDIO_InitAcquisitionSession to VI_TRUE or use niHSDIO_reset.
        '''''
        '''''If you export a signal with this function and commit the session, the signal is routed to the output terminal you specify. If you then reconfigure the signal to have a different output terminal, the previous output terminal is tristated after the session is committed. If you change the output terminal to NIHSDIO_VAL_DO_NOT_EXPORT_STR or an empty string when you commit the operation, the previous output terminal is tristated.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Signal">
        '''''Signal (clock, trigger, or event) to export.
        '''''
        '''''Defined Values:
        '''''
        '''''-   NIHSDIO_VAL_SAMPLE_CLOCK
        '''''-   NIHSDIO_VAL_REF_CLOCK
        '''''-   NIHSDIO_VAL_START_TRIGGER
        '''''-   NIHSDIO_VAL_REF_TRIGGER (dynamic acquisition only)
        '''''-   NIHSDIO_VAL_ADVANCE_TRIGGER (dynamic acquisition only)
        '''''-   NIHSDIO_VAL_DATA_ACTIVE_EVENT (dynamic generation only)
        '''''-   NIHSDIO_VAL_READY_FOR_START_EVENT
        '''''-   NIHSDIO_VAL_READY_FOR_ADVANCE_EVENT (dynamic acquisition only)
        '''''-   NIHSDIO_VAL_END_OF_RECORD_EVENT (dynamic acquisition only)
        '''''-   NIHSDIO_VAL_PAUSE_TRIGGER (dynamic generation only)
        '''''-   NIHSDIO_VAL_SCRIPT_TRIGGER (dynamic generation only - requires Signal_Identifier to describe a particular Script trigger)
        '''''-   NIHSDIO_VAL_MARKER_EVENT (dynamic generation only - requires Signal_Identifier to describe a particular Marker)
        '''''-   NIHSDIO_VAL_ONBOARD_REF_CLOCK PCI devices only) - Calling this function with Signal set to this value sets the 
        '''''NIHSDIO_ATTR_EXPORTED_ONBOARD_REF_CLOCK_OUTPUT_TERMINAL attribute
        '''''
        '''''</param>
        '''''<param name="Signal_Identifier">
        '''''Describes the signal being exported.
        '''''
        '''''Defined Values:
        '''''
        ''''' - NIHSDIO_VAL_SCRIPT_TRIGGER0
        ''''' - NIHSDIO_VAL_SCRIPT_TRIGGER1
        ''''' - NIHSDIO_VAL_SCRIPT_TRIGGER2
        ''''' - NIHSDIO_VAL_SCRIPT_TRIGGER3
        ''''' - NIHSDIO_VAL_MARKER_EVENT0
        ''''' - NIHSDIO_VAL_MARKER_EVENT1
        ''''' - NIHSDIO_VAL_MARKER_EVENT2
        ''''' - NIHSDIO_VAL_MARKER_EVENT3
        ''''' - "" (empty String) or VI_NULL
        '''''
        '''''</param>
        '''''<param name="Output_Terminal">
        '''''Output terminal where the signal is exported.
        '''''
        '''''Defined Values:
        '''''
        '''''- NIHSDIO_VAL_PFI0_STR - NIHSDIO_VAL_PFI3_STR : PFI connectors
        '''''- NIHSDIO_VAL_PXI_TRIG0_STR - NIHSDIO_VAL_PXI_TRIG7_STR : the PXI trigger backplane
        '''''- NIHSDIO_VAL_CLK_OUT_STR - CLK OUT coaxial connector on the front panel
        '''''- NIHSDIO_VAL_DDC_CLK_OUT_STR - DDC CLK OUT terminal in the Digital Data & Control Connector
        '''''- "" (empty string) or VI_NULL - the signal is not exported
        '''''
        '''''Trigger and event voltages and positions are only relevant if the destination of the event is one of the front panel connectors.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ExportSignal(ByVal Signal As Integer, ByVal Signal_Identifier As String, ByVal Output_Terminal As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.ExportSignal(Me._handle, Signal, Signal_Identifier, Output_Terminal)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Use this function to configure channels for static acquisition (if vi is an acquisition session) or static generation (if vi is a generation session). A channel cannot be simultaneously assigned to a static generation and dynamic generation.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Channel_List">
        '''''This string identifies which channels will be configured as static.
        '''''
        '''''Valid Syntax: "0-19" or "0-15,16-19" or "0-18,19"
        '''''
        '''''Special values:
        '''''-   "" (empty string) - configure ALL channels for static
        '''''-   "None" - unconfigure all static channels
        '''''
        '''''Channels cannot be configured for both static generation and dynamic generation.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function AssignStaticChannels(ByVal Channel_List As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.AssignStaticChannels(Me._handle, Channel_List)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function immediately reads the digital value on channels configured for static acquisition. Configure a channel for static acquisition using the niHSDIO_AssignStaticChannels function. Channels not configured for static acquisition return a zero.
        '''''
        '''''Values obtained from static read operations are affected by data interpretation. 
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession.
        '''''</param>
        '''''<param name="Read_Data">
        '''''Bit-value of data read from channels configured for static acquisition.
        '''''
        '''''The least significant bit of readData corresponds to the lowest physical channel number (for example, readData of 0x00F0 means channels 4-7 are logic one, while the remaining channels are logic zero or are not configured for static acquisition).
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ReadStaticU32(ByRef Read_Data As UInteger) As Integer
            Dim pInvokeResult As Integer = PInvoke.ReadStaticU32(Me._handle, Read_Data)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function writes to channels configured for static generation. You can configure a channel for static generation using the niHSDIO_AssignStaticChannels function.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Write_Data">
        '''''Bit-value of data to drive on channels configured for static generation. 1 corresponds to logic high, 0 corresponds to logic low. 
        '''''
        '''''The least significant bit of writeData corresponds to the lowest physical channel number (for example, writeData of 0xFF00 means set the lower 8 channels to 0, while setting the upper 8 channels to logic high.
        '''''
        '''''Data values in writeData corresponding to channels not configured for static generation are ignored. 
        '''''
        '''''Static channels explicitly disabled with the niHSDIO_TristateChannels function remain disabled, but the channel data value changes internally.  Re-enabling a channel with niHSDIO_TristateChannels causes the channel to drive any value that you have written to it, even while the channel was disabled.
        '''''
        '''''</param>
        '''''<param name="Channel_Mask">
        '''''Bit-value of channels to leave unchanged. 1 means to change the channel to whatever is reflected by writeData. 0 means do not alter the channel, regardless of writeData.
        '''''
        '''''The least significant bit of channelMask corresponds to the lowest physical channel number (e.g. writeData of 0xFFFF and channelMask of 0x0080 means set only channel 7 to 1; all other channels remain unchanged).
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function WriteStaticU32(ByVal Write_Data As UInteger, ByVal Channel_Mask As UInteger) As Integer
            Dim pInvokeResult As Integer = PInvoke.WriteStaticU32(Me._handle, Write_Data, Channel_Mask)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function self-calibrates the device. During self-calibration, the VCXO oscillator phase D/A converters are recalibrated.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from the function used to initialize the session.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function SelfCal() As Integer
            Dim pInvokeResult As Integer = PInvoke.SelfCal(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Changes the password that is required to initialize an external calibration session. The password may be up to four characters long.
        '''''
        '''''You can call this function from an acquisition, generation, or calibration session.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from the function used to initialize the session.
        '''''</param>
        '''''<param name="Old_Password">
        '''''The old (current) external calibration password. 
        '''''</param>
        '''''<param name="New_Password">
        '''''The new (desired) external calibration password. 
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''</returns>
        Public Function ChangeExtCalPassword(ByVal Old_Password As String, ByVal New_Password As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.ChangeExtCalPassword(Me._handle, Old_Password, New_Password)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Adjusts the voltage of the selected channel(s). The only errors that can be returned are actual calibration process errors. 
        '''''
        '''''NOTES: This function is not supported for the NI 654X/656X devices.
        '''''
        '''''This function runs a static loopback test before adjusting the voltage. You must disconnect the cable from your device to run this function. 
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from the function used to initialize the session.
        '''''</param>
        '''''<param name="Channel">
        '''''Identifies channels on which voltage will be adjusted. 
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''</returns>
        Public Function CalAdjustChannelVoltage(ByVal Channel As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.CalAdjustChannelVoltage(Me._handle, Channel)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Closes an NI-HSDIO external calibration session and, if specified, stores the new calibration constants and calibration data in the onboard EEPROM.
        '''''
        '''''NOTE: Whether you commit or cancel, the device is reset and the FPGA is reloaded afterwards. 
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from the function used to initialize the session.
        '''''</param>
        '''''<param name="Action">
        '''''The action to perform upon closing.
        '''''
        '''''Defined Values:
        '''''
        '''''NIHSDIO_VAL_EXT_CAL_COMMIT (62) - The new calibration constants and data determined during the external calibration session are stored in the onboard EEPROM, given that the calibration was complete and passed successfully.
        '''''NIHSDIO_VAL_EXT_CAL_CANCEL (63) - No changes are made to the calibration constants and data in the EEPROM.  
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''</returns>
        Public Function CloseExtCal(ByVal Action As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.CloseExtCal(Me._handle, Action)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function performs a self-test on the device and returns the test results. The self-test function performs a simple series of tests that ensure the device is powered up and responding. Complete functional testing and calibration are not performed by this function.
        '''''
        '''''This function is internal and does not affect external I/O connections or connections between devices.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Self_Test_Result">
        '''''This control contains the value returned from the device self-test.
        '''''
        '''''Self-test Code Description:
        '''''0 - Self-test passed
        '''''Anything else - Self-test failed
        '''''
        '''''
        '''''</param>
        '''''<param name="Self_Test_Message">
        '''''Returns the self-test response string from the device; you must pass a ViChar array at least IVI_MAX_MESSAGE_BUF_SIZE bytes in length
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function self_test(ByRef Self_Test_Result As Short, ByVal Self_Test_Message As System.Text.StringBuilder) As Integer
            Dim pInvokeResult As Integer = PInvoke.self_test(Me._handle, Self_Test_Result, Self_Test_Message)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Call this function to check the hardware to determine if your dynamic data operation has completed. You can also use this function for continuous dynamic data operations to poll for error conditions.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Done">
        '''''VI_TRUE is returned if the data operation is complete or an error has occurred.
        '''''
        '''''VI_FALSE is returned if the data operation has not completed.
        '''''
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function IsDone(ByRef Done As Boolean) As Integer
            Dim DoneAsUShort As UShort
            Dim pInvokeResult As Integer = PInvoke.IsDone(Me._handle, DoneAsUShort)
            Done = System.Convert.ToBoolean(DoneAsUShort)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Use this function to force a channel into a high-impedance state.  The effect is immediate - it does not require the session be committed.  The channel will remain tristated regardless of what other software commands are called.  Call this function again and pass VI_FALSE into the Tristate parameter to allow other software commands to control the channel normally.
        '''''
        '''''Channels are kept in a high-impedance state while the session remains open. Closing the session does not affect the high-impedance state of the channel, but future sessions can now control it.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<param name="Channel_List">
        '''''This string identifies which channels will be tristated. Channels not specified in this list are unaffected.
        '''''
        '''''Syntax examples: "2-15" or "0-3, 5, 8-15" or "0, 3, 10"
        '''''
        '''''
        '''''</param>
        '''''<param name="Tristate">
        '''''Defined Values:
        '''''
        '''''VI_TRUE: Force the channels specified in Channel_List to remain tristated, ignoring future software commands.
        '''''
        '''''VI_FALSE: Allow the channels specified in Channel_List to be untristated by future software commands.
        '''''
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function TristateChannels(ByVal Channel_List As String, ByVal Tristate As Boolean) As Integer
            Dim pInvokeResult As Integer = PInvoke.TristateChannels(Me._handle, Channel_List, System.Convert.ToUInt16(Tristate))
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Programs the hardware for the dynamic data operation using the attributes you select. Before entering the committed state, most attribute values are stored in software only; these values have not yet been programmed to the hardware. Once the session is committed, the hardware is configured.
        '''''
        '''''For many operations it is not necessary to explicitly call this function because the following functions implicitly commit:
        '''''niHSDIO_Initiate 
        '''''niHSDIO_ReadWaveformU32
        '''''niHSDIO_WriteNamedWaveformU32
        '''''niHSDIO_WriteScript
        '''''
        '''''Start the operation with niHSDIO_Initiate. Running this function while a dynamic operation is in progress returns an error. Committing only programs attributes changed since previous commits.
        '''''
        '''''NOTE: Committing some attributes may have immediate effects seen on external instrument connectors. Voltage levels are an example of an attribute with an immediate effect when committed.
        '''''
        '''''Before committing a session that requires an external clock, ensure the external clock is available. Otherwise you receive an error that the device could not find or lock to the external clock.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from the function used to initialize the session.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function CommitDynamic() As Integer
            Dim pInvokeResult As Integer = PInvoke.CommitDynamic(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Programs the hardware for the static data operation using the attributes you select. Before entering the committed state, most attribute values are stored in software only; these values have not yet been programmed to the hardware. Once the session is committed, the hardware is configured.
        '''''
        '''''For most static operations it is not necessary to explicitly call niHSDIO_CommitStatic because the following functions implicitly commit:
        '''''niHSDIO_ReadStaticU32
        '''''niHSDIO_WriteStaticU32
        '''''
        '''''Committing only programs attributes changed since previous commits.
        '''''
        '''''NOTE: Committing some attributes may have immediate effects seen on external instrument connectors. Voltage levels are an example of an attribute with an immediate effect when committed.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from the function used to initialize the session.
        '''''
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function CommitStatic() As Integer
            Dim pInvokeResult As Integer = PInvoke.CommitStatic(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Call this function to reset the session to its initial state. All channels and front panel terminals are put into a high-impedance state. All software attributes are reset to their initial values.
        '''''
        '''''During a reset, routes of signals between this and other devices are released, regardless of which device created the route. For instance, a trigger signal being exported to a PXI Trigger line and used by another device will no longer be exported.
        '''''
        '''''niHSDIO_reset is applied to the ENTIRE device. If you have both a generation and an acquisition session active, the niHSDIO_reset resets the current session, including attributes, and invalidates the other session if it is committed or running. The other session must be closed.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function reset() As Integer
            Dim pInvokeResult As Integer = PInvoke.reset(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Call this function to reset the device to its initial state and reload its FPGA. All channels and front panel terminals are put into a high-impedance state. All software attributes are reset to their initial values.  The entire contents of the FPGA and EEPROM files are reloaded. Use this function to re-enable your device if it has disabled itself because the device temperature has risen above its optimal operating temperature.
        '''''
        '''''During a device reset, routes of signals between this and other devices are released, regardless of which device created the route. For instance, a trigger signal being exported to a PXI Trigger line and used by another device will no longer be exported.
        '''''
        '''''niHSDIO_ResetDevice is applied to the ENTIRE device. If you have both a generation and an acquisition session active, the niHSDIO_ResetDevice resets the current session, including attributes, and invalidates the other session if it is committed or running. The other session must be closed.
        '''''
        '''''
        '''''Generally, calling niHSDIO_reset is acceptable instead of calling niHSDIO_ResetDevice. niHSDIO_reset executes more quickly. 
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''This handle identifies your instrument session. vi was obtained from niHSDIO_InitAcquisitionSession or niHSDIO_InitGenerationSession.
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation. To obtain a text description of the status code, call niHSDIO_error_message. To obtain additional information concerning the error condition, use niHSDIO_GetError and niHSDIO_ClearError.
        '''''
        '''''The general meaning of the status code is as follows:
        '''''
        '''''Value                  Meaning
        '''''-------------------------------
        '''''0                      Success
        '''''Positive Values        Warnings
        '''''Negative Values        Errors
        '''''
        '''''</returns>
        Public Function ResetDevice() As Integer
            Dim pInvokeResult As Integer = PInvoke.ResetDevice(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        Public Overloads Sub Dispose() Implements System.IDisposable.Dispose
            Me.Dispose(True)
            System.GC.SuppressFinalize(Me)
        End Sub

        Private Overloads Sub Dispose(ByVal disposing As Boolean)
            If (Me._disposed = False) Then
                PInvoke.close(Me._handle)
                Me._handle = System.IntPtr.Zero
            End If
            Me._disposed = True
        End Sub

        Protected Overrides Sub Finalize()
            Me.Dispose(False)
        End Sub

        Private Class PInvoke

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_InitAcquisitionSession", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function InitAcquisitionSession(ByVal Resource_Name As String, ByVal ID_Query As UShort, ByVal Reset_Instrument As UShort, ByVal Option_String As String, ByRef Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_InitGenerationSession", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function InitGenerationSession(ByVal Resource_Name As String, ByVal ID_Query As UShort, ByVal Reset_Instrument As UShort, ByVal Option_String As String, ByRef Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_InitExtCal", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function InitExtCal(ByVal Resource_Name As String, ByVal Password As String, ByRef Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureDataVoltageLogicFamily", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureDataVoltageLogicFamily(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Logic_Family As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureDataVoltageCustomLevels", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureDataVoltageCustomLevels(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Low_Level As Double, ByVal High_Level As Double) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureTriggerVoltageLogicFamily", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureTriggerVoltageLogicFamily(ByVal Instrument_Handle As System.IntPtr, ByVal Logic_Family As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureTriggerVoltageCustomLevels", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureTriggerVoltageCustomLevels(ByVal Instrument_Handle As System.IntPtr, ByVal Low_Level As Double, ByVal High_Level As Double) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureEventVoltageLogicFamily", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureEventVoltageLogicFamily(ByVal Instrument_Handle As System.IntPtr, ByVal Logic_Family As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureEventVoltageCustomLevels", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureEventVoltageCustomLevels(ByVal Instrument_Handle As System.IntPtr, ByVal Low_Level As Double, ByVal High_Level As Double) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_AssignDynamicChannels", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function AssignDynamicChannels(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_Initiate", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function Initiate(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_WaitUntilDone", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function WaitUntilDone(ByVal Instrument_Handle As System.IntPtr, ByVal Max_Time_Milliseconds As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_Abort", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function Abort(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureAcquisitionSize", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureAcquisitionSize(ByVal Instrument_Handle As System.IntPtr, ByVal Samples_Per_Record As Integer, ByVal Number_Of_Records As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureDataInterpretation", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureDataInterpretation(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Data_Interpretation As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ReadWaveformU32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ReadWaveformU32(ByVal Instrument_Handle As System.IntPtr, ByVal Samples_To_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByRef Number_Of_Samples_Read As Integer, <[In](), Out()> ByVal Data As UInteger()) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_FetchWaveformU32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function FetchWaveformU32(ByVal Instrument_Handle As System.IntPtr, ByVal Samples_To_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByRef Number_Of_Samples_Read As Integer, <[In](), Out()> ByVal Data As UInteger()) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ReadWaveformU16", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ReadWaveformU16(ByVal Instrument_Handle As System.IntPtr, ByVal Samples_To_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByRef Number_Of_Samples_Read As Integer, <[In](), Out()> ByVal Data As Short()) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_FetchWaveformU16", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function FetchWaveformU16(ByVal Instrument_Handle As System.IntPtr, ByVal Samples_To_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByRef Number_Of_Samples_Read As Integer, <[In](), Out()> ByVal Data As Short()) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ReadWaveformU8", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ReadWaveformU8(ByVal Instrument_Handle As System.IntPtr, ByVal Samples_To_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByRef Number_Of_Samples_Read As Integer, <[In](), Out()> ByVal Data As Byte()) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_FetchWaveformU8", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function FetchWaveformU8(ByVal Instrument_Handle As System.IntPtr, ByVal Samples_To_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByRef Number_Of_Samples_Read As Integer, <[In](), Out()> ByVal Data As Byte()) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ReadMultiRecordU32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ReadMultiRecordU32(ByVal Instrument_Handle As System.IntPtr, ByVal Samples_To_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByVal Starting_Record As Integer, ByVal Records_To_Read As Integer, ByVal Waveform_Data As UInteger(), ByVal Waveform_Info As nihsdio_wfminfo) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_FetchMultiRecordU32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function FetchMultiRecordU32(ByVal Instrument_Handle As System.IntPtr, ByVal Samples_To_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByVal Starting_Record As Integer, ByVal Records_To_Read As Integer, ByVal Waveform_Data As UInteger(), ByVal Waveform_Info As nihsdio_wfminfo) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ReadMultiRecordU16", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ReadMultiRecordU16(ByVal Instrument_Handle As System.IntPtr, ByVal Max_Time_Milliseconds As Integer, ByVal Samples_To_Read As Integer, ByVal Starting_Record As Integer, ByVal Records_To_Read As Integer, ByVal Waveform_Data As Short(), ByVal Waveform_Info As nihsdio_wfminfo) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_FetchMultiRecordU16", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function FetchMultiRecordU16(ByVal Instrument_Handle As System.IntPtr, ByVal Max_Time_Milliseconds As Integer, ByVal Samples_To_Read As Integer, ByVal Starting_Record As Integer, ByVal Records_To_Read As Integer, ByVal Waveform_Data As Short(), ByVal Waveform_Info As nihsdio_wfminfo) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ReadMultiRecordU8", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ReadMultiRecordU8(ByVal Instrument_Handle As System.IntPtr, ByVal Samples_To_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByVal Starting_Record As Integer, ByVal Records_To_Read As Integer, ByVal Waveform_Data As Byte(), ByVal Waveform_Info As nihsdio_wfminfo) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_FetchMultiRecordU8", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function FetchMultiRecordU8(ByVal Instrument_Handle As System.IntPtr, ByVal Samples_To_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByVal Starting_Record As Integer, ByVal Records_To_Read As Integer, ByVal Waveform_Data As Byte(), ByVal Waveform_Info As nihsdio_wfminfo) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_FetchWaveformDirectDMA", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function FetchWaveformDirectDMA(ByVal Instrument_Handle As System.IntPtr, ByVal Max_Time_Milliseconds As Integer, ByVal Samples_To_Read As Integer, ByVal Buffer_Size As UInteger, ByVal Buffer_Address As System.IntPtr, ByVal Waveform_Info As nihsdio_wfminfo, ByVal Offset_to_First_Sample As UInteger) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_HWC_FetchSampleErrors", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function HWC_FetchSampleErrors(ByVal Instrument_Handle As System.IntPtr, ByVal Sample_Errors_to_Read As Integer, ByVal Max_Time_Milliseconds As Integer, ByRef Number_Of_Samples_Error_Read As Integer, <[In](), Out()> ByVal Error_Sample_Numbers As Double(), <[In](), Out()> ByVal Error_Bits As UInteger(), <[In](), Out()> ByVal Error_Repeat_Counts As UInteger(), ByRef Reserved_1 As UInteger, ByRef Reserved_2 As UInteger) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_WriteNamedWaveformU32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function WriteNamedWaveformU32(ByVal Instrument_Handle As System.IntPtr, ByVal Waveform_Name As String, ByVal Samples_To_Write As Integer, ByVal Data As UInteger()) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_WriteNamedWaveformU16", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function WriteNamedWaveformU16(ByVal Instrument_Handle As System.IntPtr, ByVal Waveform_Name As String, ByVal Samples_To_Write As Integer, ByVal Data As Short()) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_WriteNamedWaveformU8", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function WriteNamedWaveformU8(ByVal Instrument_Handle As System.IntPtr, ByVal Waveform_Name As String, ByVal Samples_To_Write As Integer, ByVal Data As Byte()) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_WriteNamedWaveformWDT", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function WriteNamedWaveformWDT(ByVal Instrument_Handle As System.IntPtr, ByVal Waveform_Name As String, ByVal Samples_To_Write As Integer, ByVal Data_Layout As Integer, ByVal Data As Byte()) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_WriteNamedWaveformFromFileHWS", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function WriteNamedWaveformFromFileHWS(ByVal Instrument_Handle As System.IntPtr, ByVal Waveform_Name As String, ByVal File_Path As String, ByVal Use_Rate_From_Waveform As UShort, ByRef Waveform_Size As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureIdleState", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureIdleState(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Idle_State As String) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureIdleStateU32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureIdleStateU32(ByVal Instrument_Handle As System.IntPtr, ByVal Idle_State As UInteger) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureInitialState", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureInitialState(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Initial_State As String) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureInitialStateU32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureInitialStateU32(ByVal Instrument_Handle As System.IntPtr, ByVal Initial_State As UInteger) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureGenerationRepeat", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureGenerationRepeat(ByVal Instrument_Handle As System.IntPtr, ByVal Repeat_Mode As Integer, ByVal Repeat_Count As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureWaveformToGenerate", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureWaveformToGenerate(ByVal Instrument_Handle As System.IntPtr, ByVal Waveform_Name As String) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_AllocateNamedWaveform", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function AllocateNamedWaveform(ByVal Instrument_Handle As System.IntPtr, ByVal Waveform_Name As String, ByVal Size_In_Samples As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_SetNamedWaveformNextWritePosition", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetNamedWaveformNextWritePosition(ByVal Instrument_Handle As System.IntPtr, ByVal Waveform_Name As String, ByVal Position As Integer, ByVal Offset As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_DeleteNamedWaveform", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function DeleteNamedWaveform(ByVal Instrument_Handle As System.IntPtr, ByVal Waveform_Name As String) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureGenerationMode", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureGenerationMode(ByVal Instrument_Handle As System.IntPtr, ByVal Generation_Mode As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_WriteScript", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function WriteScript(ByVal Instrument_Handle As System.IntPtr, ByVal Script As String) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureScriptToGenerate", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureScriptToGenerate(ByVal Instrument_Handle As System.IntPtr, ByVal Script_Name As String) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureSampleClock", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureSampleClock(ByVal Instrument_Handle As System.IntPtr, ByVal Clock_Source As String, ByVal Clock_Rate As Double) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureDataPosition", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureDataPosition(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Position As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureDataPositionDelay", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureDataPositionDelay(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Delay As Double) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureRefClock", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureRefClock(ByVal Instrument_Handle As System.IntPtr, ByVal Clock_Source As String, ByVal Clock_Rate As Double) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_AdjustSampleClockRelativeDelay", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function AdjustSampleClockRelativeDelay(ByVal Instrument_Handle As System.IntPtr, ByVal Adjustment_Time As Double) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureDigitalEdgeStartTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureDigitalEdgeStartTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Source As String, ByVal Edge As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigurePatternMatchStartTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigurePatternMatchStartTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Pattern As String, ByVal Trigger_When As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigurePatternMatchStartTriggerU32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigurePatternMatchStartTriggerU32(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Pattern As UInteger, ByVal Trigger_When As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureSoftwareStartTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureSoftwareStartTrigger(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_DisableStartTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function DisableStartTrigger(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureDigitalEdgeRefTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureDigitalEdgeRefTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Source As String, ByVal Edge As Integer, ByVal Pretrigger_Samples As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigurePatternMatchRefTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigurePatternMatchRefTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Pattern As String, ByVal Trigger_When As Integer, ByVal Pretrigger_Samples As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigurePatternMatchRefTriggerU32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigurePatternMatchRefTriggerU32(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Pattern As UInteger, ByVal Trigger_When As Integer, ByVal Pretrigger_Samples As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureSoftwareRefTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureSoftwareRefTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Pretrigger_Samples As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_DisableRefTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function DisableRefTrigger(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureDigitalEdgeAdvanceTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureDigitalEdgeAdvanceTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Source As String, ByVal Edge As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigurePatternMatchAdvanceTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigurePatternMatchAdvanceTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Pattern As String, ByVal Trigger_When As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigurePatternMatchAdvanceTriggerU32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigurePatternMatchAdvanceTriggerU32(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Pattern As UInteger, ByVal Trigger_When As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureSoftwareAdvanceTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureSoftwareAdvanceTrigger(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_DisableAdvanceTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function DisableAdvanceTrigger(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureDigitalEdgeScriptTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureDigitalEdgeScriptTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Trigger_ID As String, ByVal Source As String, ByVal Edge As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureDigitalLevelScriptTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureDigitalLevelScriptTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Trigger_ID As String, ByVal Source As String, ByVal Trigger_When As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureSoftwareScriptTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureSoftwareScriptTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Trigger_ID As String) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_DisableScriptTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function DisableScriptTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Trigger_ID As String) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigureDigitalLevelPauseTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureDigitalLevelPauseTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Source As String, ByVal Trigger_When As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigurePatternMatchPauseTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigurePatternMatchPauseTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Pattern As String, ByVal Trigger_When As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ConfigurePatternMatchPauseTriggerU32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigurePatternMatchPauseTriggerU32(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Pattern As UInteger, ByVal Trigger_When As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_DisablePauseTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function DisablePauseTrigger(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_SendSoftwareEdgeTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SendSoftwareEdgeTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Trigger As Integer, ByVal Trigger_Identifier As String) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ExportSignal", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ExportSignal(ByVal Instrument_Handle As System.IntPtr, ByVal Signal As Integer, ByVal Signal_Identifier As String, ByVal Output_Terminal As String) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_AssignStaticChannels", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function AssignStaticChannels(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ReadStaticU32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ReadStaticU32(ByVal Instrument_Handle As System.IntPtr, ByRef Read_Data As UInteger) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_WriteStaticU32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function WriteStaticU32(ByVal Instrument_Handle As System.IntPtr, ByVal Write_Data As UInteger, ByVal Channel_Mask As UInteger) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_SelfCal", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SelfCal(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ChangeExtCalPassword", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ChangeExtCalPassword(ByVal Instrument_Handle As System.IntPtr, ByVal Old_Password As String, ByVal New_Password As String) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_CalAdjustChannelVoltage", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function CalAdjustChannelVoltage(ByVal Instrument_Handle As System.IntPtr, ByVal Channel As String) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_CloseExtCal", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function CloseExtCal(ByVal Instrument_Handle As System.IntPtr, ByVal Action As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_self_test", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function self_test(ByVal Instrument_Handle As System.IntPtr, ByRef Self_Test_Result As Short, ByVal Self_Test_Message As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_IsDone", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function IsDone(ByVal Instrument_Handle As System.IntPtr, ByRef Done As UShort) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_TristateChannels", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function TristateChannels(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Tristate As UShort) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_CommitDynamic", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function CommitDynamic(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_CommitStatic", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function CommitStatic(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_reset", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function reset(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_ResetDevice", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ResetDevice(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_close", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function close(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_error_message", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function error_message(ByVal Instrument_Handle As System.IntPtr, ByVal Error_Code As Integer, ByVal Error_Message_2 As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_GetAttributeViBoolean", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViBoolean(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Attribute_ID As Integer, ByRef Value As UShort) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_GetAttributeViInt32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViInt32(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Attribute_ID As Integer, ByRef Value As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_GetAttributeViReal64", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViReal64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Attribute_ID As Integer, ByRef Value As Double) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_GetAttributeViSession", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViSession(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Attribute_ID As Integer, ByRef Value As System.IntPtr) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_GetAttributeViString", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViString(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Attribute_ID As Integer, ByVal Buf_Size As Integer, ByVal Value As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_SetAttributeViBoolean", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViBoolean(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Attribute_ID As Integer, ByVal Value As UShort) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_SetAttributeViInt32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViInt32(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Attribute_ID As Integer, ByVal Value As Integer) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_SetAttributeViReal64", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViReal64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Attribute_ID As Integer, ByVal Value As Double) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_SetAttributeViSession", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViSession(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Attribute_ID As Integer, ByVal Value As System.IntPtr) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_SetAttributeViString", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViString(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Attribute_ID As Integer, ByVal Value As String) As Integer
            End Function

            <DllImport("niHSDIO.dll", EntryPoint:="niHSDIO_GetError", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetError(ByVal Instrument_Handle As System.IntPtr, ByRef Error_Code As Integer, ByVal Error_Description_Buffer_Size As Integer, ByVal Error_Description As System.Text.StringBuilder) As Integer
            End Function


            Public Shared Function TestForError(ByVal handle As System.IntPtr, ByVal status As Integer) As Integer
                If (status < 0) Then
                    PInvoke.ThrowError(handle, status)
                End If
                Return status
            End Function

            Public Shared Function ThrowError(ByVal handle As System.IntPtr, ByVal code As Integer) As Integer
                Dim status As Integer
                Dim size As Integer = PInvoke.GetError(handle, status, 0, Nothing)
                Dim msg As System.Text.StringBuilder = New System.Text.StringBuilder
                If (size >= 0) Then
                    msg.Capacity = size
                    PInvoke.GetError(handle, status, size, msg)
                End If
                Throw New System.Runtime.InteropServices.ExternalException(msg.ToString, code)
            End Function
        End Class
    End Class

    Public Class niHSDIOConstants

        Public Const _50vLogic As Integer = 5

        Public Const _33vLogic As Integer = 6

        Public Const _25vLogic As Integer = 7

        Public Const _18vLogic As Integer = 8

        Public Const HighOrLow As Integer = 3

        Public Const ValidOrInvalid As Integer = 4

        Public Const GroupBySample As Integer = 71

        Public Const GroupByChannel As Integer = 72

        Public Const Finite As Integer = 16

        Public Const Continuous As Integer = 17

        Public Const CurrentPosition As Integer = 45

        Public Const StartOfWaveform As Integer = 44

        Public Const Waveform As Integer = 14

        Public Const Scripted As Integer = 15

        Public Const OnBoardClockStr As String = "OnBoardClock"

        Public Const ClkInStr As String = "ClkIn"

        Public Const PxiStarStr As String = "PXI_STAR"

        Public Const StrobeStr As String = "STROBE"

        Public Const SampleClockRisingEdge As Integer = 18

        Public Const SampleClockFallingEdge As Integer = 19

        Public Const DelayFromSampleClockRisingEdge As Integer = 20

        Public Const NoneStr As String = "None"

        Public Const PxiClk10Str As String = "PXI_CLK10"

        Public Const Rtsi7Str As String = "RTSI7"

        Public Const Pfi0Str As String = "PFI0"

        Public Const Pfi1Str As String = "PFI1"

        Public Const Pfi2Str As String = "PFI2"

        Public Const Pfi3Str As String = "PFI3"

        Public Const PxiTrig0Str As String = "PXI_Trig0"

        Public Const PxiTrig1Str As String = "PXI_Trig1"

        Public Const PxiTrig2Str As String = "PXI_Trig2"

        Public Const PxiTrig3Str As String = "PXI_Trig3"

        Public Const PxiTrig4Str As String = "PXI_Trig4"

        Public Const PxiTrig5Str As String = "PXI_Trig5"

        Public Const PxiTrig6Str As String = "PXI_Trig6"

        Public Const PxiTrig7Str As String = "PXI_Trig7"

        Public Const RisingEdge As Integer = 12

        Public Const FallingEdge As Integer = 13

        Public Const PatternMatches As Integer = 36

        Public Const PatternDoesNotMatch As Integer = 37

        Public Const ScriptTrigger0 As String = "scriptTrigger0"

        Public Const ScriptTrigger1 As String = "scriptTrigger1"

        Public Const ScriptTrigger2 As String = "scriptTrigger2"

        Public Const ScriptTrigger3 As String = "scriptTrigger3"

        Public Const High As Integer = 34

        Public Const Low As Integer = 35

        Public Const StartTrigger As Integer = 53

        Public Const RefTrigger As Integer = 54

        Public Const ScriptTrigger As Integer = 58

        Public Const SampleClock As Integer = 51

        Public Const RefClock As Integer = 52

        Public Const AdvanceTrigger As Integer = 61

        Public Const PauseTrigger As Integer = 57

        Public Const DataActiveEvent As Integer = 55

        Public Const MarkerEvent As Integer = 59

        Public Const ReadyForStartEvent As Integer = 56

        Public Const ReadyForAdvanceEvent As Integer = 66

        Public Const EndOfRecordEvent As Integer = 68

        Public Const OnboardRefClock As Integer = 60

        Public Const DoNotExportStr As String = ""

        Public Const ClkOutStr As String = "ClkOut"

        Public Const DdcClkOutStr As String = "DDC_ClkOut"

        Public Const MarkerEvent0 As String = "marker0"

        Public Const MarkerEvent1 As String = "marker1"

        Public Const MarkerEvent2 As String = "marker2"

        Public Const MarkerEvent3 As String = "marker3"

        Public Const ExtCalCommit As Integer = 62

        Public Const ExtCalCancel As Integer = 63
    End Class
End Namespace